import * as $protobuf from "protobufjs";
import '@types/long';

/** Namespace meerkat. */
export namespace meerkat {

    /** Properties of a UIAnswer. */
    interface IUIAnswer {

        /** UIAnswer answer */
        answer?: Uint8Array;

        /** UIAnswer description */
        description?: string;
    }

    /** Represents a UIAnswer. */
    class UIAnswer {

        /**
         * Constructs a new UIAnswer.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IUIAnswer);

        /** UIAnswer answer. */
        public answer: Uint8Array;

        /** UIAnswer description. */
        public description: string;

        /**
         * Creates a new UIAnswer instance using the specified properties.
         * @param [properties] Properties to set
         * @returns UIAnswer instance
         */
        public static create(properties?: meerkat.IUIAnswer): meerkat.UIAnswer;

        /**
         * Encodes the specified UIAnswer message. Does not implicitly {@link meerkat.UIAnswer.verify|verify} messages.
         * @param message UIAnswer message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IUIAnswer, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified UIAnswer message, length delimited. Does not implicitly {@link meerkat.UIAnswer.verify|verify} messages.
         * @param message UIAnswer message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IUIAnswer, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a UIAnswer message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns UIAnswer
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.UIAnswer;

        /**
         * Decodes a UIAnswer message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns UIAnswer
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.UIAnswer;

        /**
         * Verifies a UIAnswer message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a UIAnswer message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns UIAnswer
         */
        public static fromObject(object: { [k: string]: any }): meerkat.UIAnswer;

        /**
         * Creates a plain object from a UIAnswer message. Also converts values to other types if specified.
         * @param message UIAnswer
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.UIAnswer, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this UIAnswer to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a ListOfAnswers. */
    interface IListOfAnswers {

        /** ListOfAnswers answers */
        answers?: meerkat.IUIAnswer[];
    }

    /** Represents a ListOfAnswers. */
    class ListOfAnswers {

        /**
         * Constructs a new ListOfAnswers.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IListOfAnswers);

        /** ListOfAnswers answers. */
        public answers: meerkat.IUIAnswer[];

        /**
         * Creates a new ListOfAnswers instance using the specified properties.
         * @param [properties] Properties to set
         * @returns ListOfAnswers instance
         */
        public static create(properties?: meerkat.IListOfAnswers): meerkat.ListOfAnswers;

        /**
         * Encodes the specified ListOfAnswers message. Does not implicitly {@link meerkat.ListOfAnswers.verify|verify} messages.
         * @param message ListOfAnswers message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IListOfAnswers, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified ListOfAnswers message, length delimited. Does not implicitly {@link meerkat.ListOfAnswers.verify|verify} messages.
         * @param message ListOfAnswers message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IListOfAnswers, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a ListOfAnswers message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns ListOfAnswers
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.ListOfAnswers;

        /**
         * Decodes a ListOfAnswers message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns ListOfAnswers
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.ListOfAnswers;

        /**
         * Verifies a ListOfAnswers message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a ListOfAnswers message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns ListOfAnswers
         */
        public static fromObject(object: { [k: string]: any }): meerkat.ListOfAnswers;

        /**
         * Creates a plain object from a ListOfAnswers message. Also converts values to other types if specified.
         * @param message ListOfAnswers
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.ListOfAnswers, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this ListOfAnswers to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a UIAnswers. */
    interface IUIAnswers {

        /** UIAnswers AnswersType */
        AnswersType?: number;

        /** UIAnswers answers */
        answers?: meerkat.IListOfAnswers;
    }

    /** Represents a UIAnswers. */
    class UIAnswers {

        /**
         * Constructs a new UIAnswers.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IUIAnswers);

        /** UIAnswers AnswersType. */
        public AnswersType: number;

        /** UIAnswers answers. */
        public answers?: (meerkat.IListOfAnswers|null);

        /**
         * Creates a new UIAnswers instance using the specified properties.
         * @param [properties] Properties to set
         * @returns UIAnswers instance
         */
        public static create(properties?: meerkat.IUIAnswers): meerkat.UIAnswers;

        /**
         * Encodes the specified UIAnswers message. Does not implicitly {@link meerkat.UIAnswers.verify|verify} messages.
         * @param message UIAnswers message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IUIAnswers, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified UIAnswers message, length delimited. Does not implicitly {@link meerkat.UIAnswers.verify|verify} messages.
         * @param message UIAnswers message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IUIAnswers, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a UIAnswers message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns UIAnswers
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.UIAnswers;

        /**
         * Decodes a UIAnswers message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns UIAnswers
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.UIAnswers;

        /**
         * Verifies a UIAnswers message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a UIAnswers message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns UIAnswers
         */
        public static fromObject(object: { [k: string]: any }): meerkat.UIAnswers;

        /**
         * Creates a plain object from a UIAnswers message. Also converts values to other types if specified.
         * @param message UIAnswers
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.UIAnswers, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this UIAnswers to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a Question. */
    interface IQuestion {

        /** Question question */
        question?: Uint8Array;
    }

    /** Represents a Question. */
    class Question {

        /**
         * Constructs a new Question.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IQuestion);

        /** Question question. */
        public question: Uint8Array;

        /**
         * Creates a new Question instance using the specified properties.
         * @param [properties] Properties to set
         * @returns Question instance
         */
        public static create(properties?: meerkat.IQuestion): meerkat.Question;

        /**
         * Encodes the specified Question message. Does not implicitly {@link meerkat.Question.verify|verify} messages.
         * @param message Question message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IQuestion, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified Question message, length delimited. Does not implicitly {@link meerkat.Question.verify|verify} messages.
         * @param message Question message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IQuestion, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a Question message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns Question
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.Question;

        /**
         * Decodes a Question message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns Question
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.Question;

        /**
         * Verifies a Question message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a Question message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns Question
         */
        public static fromObject(object: { [k: string]: any }): meerkat.Question;

        /**
         * Creates a plain object from a Question message. Also converts values to other types if specified.
         * @param message Question
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.Question, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this Question to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a UIQuestion. */
    interface IUIQuestion {

        /** UIQuestion QuestionType */
        QuestionType?: number;

        /** UIQuestion question */
        question?: meerkat.IQuestion;
    }

    /** Represents a UIQuestion. */
    class UIQuestion {

        /**
         * Constructs a new UIQuestion.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IUIQuestion);

        /** UIQuestion QuestionType. */
        public QuestionType: number;

        /** UIQuestion question. */
        public question?: (meerkat.IQuestion|null);

        /**
         * Creates a new UIQuestion instance using the specified properties.
         * @param [properties] Properties to set
         * @returns UIQuestion instance
         */
        public static create(properties?: meerkat.IUIQuestion): meerkat.UIQuestion;

        /**
         * Encodes the specified UIQuestion message. Does not implicitly {@link meerkat.UIQuestion.verify|verify} messages.
         * @param message UIQuestion message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IUIQuestion, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified UIQuestion message, length delimited. Does not implicitly {@link meerkat.UIQuestion.verify|verify} messages.
         * @param message UIQuestion message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IUIQuestion, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a UIQuestion message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns UIQuestion
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.UIQuestion;

        /**
         * Decodes a UIQuestion message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns UIQuestion
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.UIQuestion;

        /**
         * Verifies a UIQuestion message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a UIQuestion message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns UIQuestion
         */
        public static fromObject(object: { [k: string]: any }): meerkat.UIQuestion;

        /**
         * Creates a plain object from a UIQuestion message. Also converts values to other types if specified.
         * @param message UIQuestion
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.UIQuestion, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this UIQuestion to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a BallotQuestionUIElement. */
    interface IBallotQuestionUIElement {

        /** BallotQuestionUIElement answers */
        answers?: meerkat.IUIAnswers;

        /** BallotQuestionUIElement RandomizeListOrder */
        RandomizeListOrder?: boolean;

        /** BallotQuestionUIElement question */
        question?: meerkat.IUIQuestion;
    }

    /** Represents a BallotQuestionUIElement. */
    class BallotQuestionUIElement {

        /**
         * Constructs a new BallotQuestionUIElement.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IBallotQuestionUIElement);

        /** BallotQuestionUIElement answers. */
        public answers?: (meerkat.IUIAnswers|null);

        /** BallotQuestionUIElement RandomizeListOrder. */
        public RandomizeListOrder: boolean;

        /** BallotQuestionUIElement question. */
        public question?: (meerkat.IUIQuestion|null);

        /**
         * Creates a new BallotQuestionUIElement instance using the specified properties.
         * @param [properties] Properties to set
         * @returns BallotQuestionUIElement instance
         */
        public static create(properties?: meerkat.IBallotQuestionUIElement): meerkat.BallotQuestionUIElement;

        /**
         * Encodes the specified BallotQuestionUIElement message. Does not implicitly {@link meerkat.BallotQuestionUIElement.verify|verify} messages.
         * @param message BallotQuestionUIElement message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IBallotQuestionUIElement, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified BallotQuestionUIElement message, length delimited. Does not implicitly {@link meerkat.BallotQuestionUIElement.verify|verify} messages.
         * @param message BallotQuestionUIElement message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IBallotQuestionUIElement, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a BallotQuestionUIElement message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns BallotQuestionUIElement
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.BallotQuestionUIElement;

        /**
         * Decodes a BallotQuestionUIElement message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns BallotQuestionUIElement
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.BallotQuestionUIElement;

        /**
         * Verifies a BallotQuestionUIElement message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a BallotQuestionUIElement message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns BallotQuestionUIElement
         */
        public static fromObject(object: { [k: string]: any }): meerkat.BallotQuestionUIElement;

        /**
         * Creates a plain object from a BallotQuestionUIElement message. Also converts values to other types if specified.
         * @param message BallotQuestionUIElement
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.BallotQuestionUIElement, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this BallotQuestionUIElement to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a BallotQuestionsUIElements. */
    interface IBallotQuestionsUIElements {

        /** BallotQuestionsUIElements questions */
        questions?: meerkat.IBallotQuestionUIElement[];
    }

    /** Represents a BallotQuestionsUIElements. */
    class BallotQuestionsUIElements {

        /**
         * Constructs a new BallotQuestionsUIElements.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IBallotQuestionsUIElements);

        /** BallotQuestionsUIElements questions. */
        public questions: meerkat.IBallotQuestionUIElement[];

        /**
         * Creates a new BallotQuestionsUIElements instance using the specified properties.
         * @param [properties] Properties to set
         * @returns BallotQuestionsUIElements instance
         */
        public static create(properties?: meerkat.IBallotQuestionsUIElements): meerkat.BallotQuestionsUIElements;

        /**
         * Encodes the specified BallotQuestionsUIElements message. Does not implicitly {@link meerkat.BallotQuestionsUIElements.verify|verify} messages.
         * @param message BallotQuestionsUIElements message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IBallotQuestionsUIElements, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified BallotQuestionsUIElements message, length delimited. Does not implicitly {@link meerkat.BallotQuestionsUIElements.verify|verify} messages.
         * @param message BallotQuestionsUIElements message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IBallotQuestionsUIElements, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a BallotQuestionsUIElements message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns BallotQuestionsUIElements
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.BallotQuestionsUIElements;

        /**
         * Decodes a BallotQuestionsUIElements message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns BallotQuestionsUIElements
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.BallotQuestionsUIElements;

        /**
         * Verifies a BallotQuestionsUIElements message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a BallotQuestionsUIElements message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns BallotQuestionsUIElements
         */
        public static fromObject(object: { [k: string]: any }): meerkat.BallotQuestionsUIElements;

        /**
         * Creates a plain object from a BallotQuestionsUIElements message. Also converts values to other types if specified.
         * @param message BallotQuestionsUIElements
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.BallotQuestionsUIElements, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this BallotQuestionsUIElements to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** ValueType enum. */
    enum ValueType {
        TEXT_TYPE = 0,
        AUDIO_TYPE = 1,
        IMAGE_TYPE = 2
    }

    /** Properties of a BoolMsg. */
    interface IBoolMsg {

        /** BoolMsg value */
        value?: boolean;
    }

    /** Represents a BoolMsg. */
    class BoolMsg {

        /**
         * Constructs a new BoolMsg.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IBoolMsg);

        /** BoolMsg value. */
        public value: boolean;

        /**
         * Creates a new BoolMsg instance using the specified properties.
         * @param [properties] Properties to set
         * @returns BoolMsg instance
         */
        public static create(properties?: meerkat.IBoolMsg): meerkat.BoolMsg;

        /**
         * Encodes the specified BoolMsg message. Does not implicitly {@link meerkat.BoolMsg.verify|verify} messages.
         * @param message BoolMsg message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IBoolMsg, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified BoolMsg message, length delimited. Does not implicitly {@link meerkat.BoolMsg.verify|verify} messages.
         * @param message BoolMsg message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IBoolMsg, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a BoolMsg message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns BoolMsg
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.BoolMsg;

        /**
         * Decodes a BoolMsg message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns BoolMsg
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.BoolMsg;

        /**
         * Verifies a BoolMsg message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a BoolMsg message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns BoolMsg
         */
        public static fromObject(object: { [k: string]: any }): meerkat.BoolMsg;

        /**
         * Creates a plain object from a BoolMsg message. Also converts values to other types if specified.
         * @param message BoolMsg
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.BoolMsg, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this BoolMsg to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of an IntMsg. */
    interface IIntMsg {

        /** IntMsg value */
        value?: number;
    }

    /** Represents an IntMsg. */
    class IntMsg {

        /**
         * Constructs a new IntMsg.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IIntMsg);

        /** IntMsg value. */
        public value: number;

        /**
         * Creates a new IntMsg instance using the specified properties.
         * @param [properties] Properties to set
         * @returns IntMsg instance
         */
        public static create(properties?: meerkat.IIntMsg): meerkat.IntMsg;

        /**
         * Encodes the specified IntMsg message. Does not implicitly {@link meerkat.IntMsg.verify|verify} messages.
         * @param message IntMsg message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IIntMsg, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified IntMsg message, length delimited. Does not implicitly {@link meerkat.IntMsg.verify|verify} messages.
         * @param message IntMsg message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IIntMsg, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes an IntMsg message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns IntMsg
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.IntMsg;

        /**
         * Decodes an IntMsg message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns IntMsg
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.IntMsg;

        /**
         * Verifies an IntMsg message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates an IntMsg message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns IntMsg
         */
        public static fromObject(object: { [k: string]: any }): meerkat.IntMsg;

        /**
         * Creates a plain object from an IntMsg message. Also converts values to other types if specified.
         * @param message IntMsg
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.IntMsg, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this IntMsg to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a MessageID. */
    interface IMessageID {

        /** MessageID ID */
        ID?: Uint8Array;
    }

    /** Represents a MessageID. */
    class MessageID {

        /**
         * Constructs a new MessageID.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IMessageID);

        /** MessageID ID. */
        public ID: Uint8Array;

        /**
         * Creates a new MessageID instance using the specified properties.
         * @param [properties] Properties to set
         * @returns MessageID instance
         */
        public static create(properties?: meerkat.IMessageID): meerkat.MessageID;

        /**
         * Encodes the specified MessageID message. Does not implicitly {@link meerkat.MessageID.verify|verify} messages.
         * @param message MessageID message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IMessageID, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified MessageID message, length delimited. Does not implicitly {@link meerkat.MessageID.verify|verify} messages.
         * @param message MessageID message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IMessageID, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a MessageID message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns MessageID
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.MessageID;

        /**
         * Decodes a MessageID message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns MessageID
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.MessageID;

        /**
         * Verifies a MessageID message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a MessageID message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns MessageID
         */
        public static fromObject(object: { [k: string]: any }): meerkat.MessageID;

        /**
         * Creates a plain object from a MessageID message. Also converts values to other types if specified.
         * @param message MessageID
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.MessageID, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this MessageID to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of an UnsignedBulletinBoardMessage. */
    interface IUnsignedBulletinBoardMessage {

        /** UnsignedBulletinBoardMessage tag */
        tag?: string[];

        /** UnsignedBulletinBoardMessage timestamp */
        timestamp?: google.protobuf.ITimestamp;

        /** UnsignedBulletinBoardMessage msgId */
        msgId?: Uint8Array;

        /** UnsignedBulletinBoardMessage data */
        data?: Uint8Array;
    }

    /** Represents an UnsignedBulletinBoardMessage. */
    class UnsignedBulletinBoardMessage {

        /**
         * Constructs a new UnsignedBulletinBoardMessage.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IUnsignedBulletinBoardMessage);

        /** UnsignedBulletinBoardMessage tag. */
        public tag: string[];

        /** UnsignedBulletinBoardMessage timestamp. */
        public timestamp?: (google.protobuf.ITimestamp|null);

        /** UnsignedBulletinBoardMessage msgId. */
        public msgId: Uint8Array;

        /** UnsignedBulletinBoardMessage data. */
        public data: Uint8Array;

        /** UnsignedBulletinBoardMessage dataType. */
        public dataType?: string;

        /**
         * Creates a new UnsignedBulletinBoardMessage instance using the specified properties.
         * @param [properties] Properties to set
         * @returns UnsignedBulletinBoardMessage instance
         */
        public static create(properties?: meerkat.IUnsignedBulletinBoardMessage): meerkat.UnsignedBulletinBoardMessage;

        /**
         * Encodes the specified UnsignedBulletinBoardMessage message. Does not implicitly {@link meerkat.UnsignedBulletinBoardMessage.verify|verify} messages.
         * @param message UnsignedBulletinBoardMessage message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IUnsignedBulletinBoardMessage, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified UnsignedBulletinBoardMessage message, length delimited. Does not implicitly {@link meerkat.UnsignedBulletinBoardMessage.verify|verify} messages.
         * @param message UnsignedBulletinBoardMessage message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IUnsignedBulletinBoardMessage, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes an UnsignedBulletinBoardMessage message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns UnsignedBulletinBoardMessage
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.UnsignedBulletinBoardMessage;

        /**
         * Decodes an UnsignedBulletinBoardMessage message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns UnsignedBulletinBoardMessage
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.UnsignedBulletinBoardMessage;

        /**
         * Verifies an UnsignedBulletinBoardMessage message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates an UnsignedBulletinBoardMessage message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns UnsignedBulletinBoardMessage
         */
        public static fromObject(object: { [k: string]: any }): meerkat.UnsignedBulletinBoardMessage;

        /**
         * Creates a plain object from an UnsignedBulletinBoardMessage message. Also converts values to other types if specified.
         * @param message UnsignedBulletinBoardMessage
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.UnsignedBulletinBoardMessage, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this UnsignedBulletinBoardMessage to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a BulletinBoardMessage. */
    interface IBulletinBoardMessage {

        /** BulletinBoardMessage entryNum */
        entryNum?: (number|Long);

        /** BulletinBoardMessage msg */
        msg?: meerkat.IUnsignedBulletinBoardMessage;

        /** BulletinBoardMessage sig */
        sig?: meerkat.ISignature[];
    }

    /** Represents a BulletinBoardMessage. */
    class BulletinBoardMessage {

        /**
         * Constructs a new BulletinBoardMessage.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IBulletinBoardMessage);

        /** BulletinBoardMessage entryNum. */
        public entryNum: (number|Long);

        /** BulletinBoardMessage msg. */
        public msg?: (meerkat.IUnsignedBulletinBoardMessage|null);

        /** BulletinBoardMessage sig. */
        public sig: meerkat.ISignature[];

        /**
         * Creates a new BulletinBoardMessage instance using the specified properties.
         * @param [properties] Properties to set
         * @returns BulletinBoardMessage instance
         */
        public static create(properties?: meerkat.IBulletinBoardMessage): meerkat.BulletinBoardMessage;

        /**
         * Encodes the specified BulletinBoardMessage message. Does not implicitly {@link meerkat.BulletinBoardMessage.verify|verify} messages.
         * @param message BulletinBoardMessage message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IBulletinBoardMessage, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified BulletinBoardMessage message, length delimited. Does not implicitly {@link meerkat.BulletinBoardMessage.verify|verify} messages.
         * @param message BulletinBoardMessage message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IBulletinBoardMessage, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a BulletinBoardMessage message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns BulletinBoardMessage
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.BulletinBoardMessage;

        /**
         * Decodes a BulletinBoardMessage message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns BulletinBoardMessage
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.BulletinBoardMessage;

        /**
         * Verifies a BulletinBoardMessage message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a BulletinBoardMessage message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns BulletinBoardMessage
         */
        public static fromObject(object: { [k: string]: any }): meerkat.BulletinBoardMessage;

        /**
         * Creates a plain object from a BulletinBoardMessage message. Also converts values to other types if specified.
         * @param message BulletinBoardMessage
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.BulletinBoardMessage, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this BulletinBoardMessage to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a BulletinBoardMessageList. */
    interface IBulletinBoardMessageList {

        /** BulletinBoardMessageList message */
        message?: meerkat.IBulletinBoardMessage[];
    }

    /** Represents a BulletinBoardMessageList. */
    class BulletinBoardMessageList {

        /**
         * Constructs a new BulletinBoardMessageList.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IBulletinBoardMessageList);

        /** BulletinBoardMessageList message. */
        public message: meerkat.IBulletinBoardMessage[];

        /**
         * Creates a new BulletinBoardMessageList instance using the specified properties.
         * @param [properties] Properties to set
         * @returns BulletinBoardMessageList instance
         */
        public static create(properties?: meerkat.IBulletinBoardMessageList): meerkat.BulletinBoardMessageList;

        /**
         * Encodes the specified BulletinBoardMessageList message. Does not implicitly {@link meerkat.BulletinBoardMessageList.verify|verify} messages.
         * @param message BulletinBoardMessageList message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IBulletinBoardMessageList, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified BulletinBoardMessageList message, length delimited. Does not implicitly {@link meerkat.BulletinBoardMessageList.verify|verify} messages.
         * @param message BulletinBoardMessageList message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IBulletinBoardMessageList, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a BulletinBoardMessageList message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns BulletinBoardMessageList
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.BulletinBoardMessageList;

        /**
         * Decodes a BulletinBoardMessageList message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns BulletinBoardMessageList
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.BulletinBoardMessageList;

        /**
         * Verifies a BulletinBoardMessageList message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a BulletinBoardMessageList message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns BulletinBoardMessageList
         */
        public static fromObject(object: { [k: string]: any }): meerkat.BulletinBoardMessageList;

        /**
         * Creates a plain object from a BulletinBoardMessageList message. Also converts values to other types if specified.
         * @param message BulletinBoardMessageList
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.BulletinBoardMessageList, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this BulletinBoardMessageList to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** FilterType enum. */
    enum FilterType {
        MSG_ID = 0,
        EXACT_ENTRY = 1,
        MAX_ENTRY = 2,
        MIN_ENTRY = 3,
        SIGNER_ID = 4,
        TAG = 5,
        AFTER_TIME = 6,
        BEFORE_TIME = 7,
        MAX_MESSAGES = 8
    }

    /** Properties of a MessageFilter. */
    interface IMessageFilter {

        /** MessageFilter type */
        type?: meerkat.FilterType;

        /** MessageFilter id */
        id?: Uint8Array;

        /** MessageFilter entry */
        entry?: (number|Long);

        /** MessageFilter tag */
        tag?: string;

        /** MessageFilter maxMessages */
        maxMessages?: (number|Long);

        /** MessageFilter timestamp */
        timestamp?: google.protobuf.ITimestamp;
    }

    /** Represents a MessageFilter. */
    class MessageFilter {

        /**
         * Constructs a new MessageFilter.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IMessageFilter);

        /** MessageFilter type. */
        public type: meerkat.FilterType;

        /** MessageFilter id. */
        public id: Uint8Array;

        /** MessageFilter entry. */
        public entry: (number|Long);

        /** MessageFilter tag. */
        public tag: string;

        /** MessageFilter maxMessages. */
        public maxMessages: (number|Long);

        /** MessageFilter timestamp. */
        public timestamp?: (google.protobuf.ITimestamp|null);

        /** MessageFilter filter. */
        public filter?: string;

        /**
         * Creates a new MessageFilter instance using the specified properties.
         * @param [properties] Properties to set
         * @returns MessageFilter instance
         */
        public static create(properties?: meerkat.IMessageFilter): meerkat.MessageFilter;

        /**
         * Encodes the specified MessageFilter message. Does not implicitly {@link meerkat.MessageFilter.verify|verify} messages.
         * @param message MessageFilter message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IMessageFilter, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified MessageFilter message, length delimited. Does not implicitly {@link meerkat.MessageFilter.verify|verify} messages.
         * @param message MessageFilter message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IMessageFilter, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a MessageFilter message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns MessageFilter
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.MessageFilter;

        /**
         * Decodes a MessageFilter message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns MessageFilter
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.MessageFilter;

        /**
         * Verifies a MessageFilter message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a MessageFilter message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns MessageFilter
         */
        public static fromObject(object: { [k: string]: any }): meerkat.MessageFilter;

        /**
         * Creates a plain object from a MessageFilter message. Also converts values to other types if specified.
         * @param message MessageFilter
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.MessageFilter, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this MessageFilter to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a MessageFilterList. */
    interface IMessageFilterList {

        /** MessageFilterList filter */
        filter?: meerkat.IMessageFilter[];
    }

    /** Represents a MessageFilterList. */
    class MessageFilterList {

        /**
         * Constructs a new MessageFilterList.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IMessageFilterList);

        /** MessageFilterList filter. */
        public filter: meerkat.IMessageFilter[];

        /**
         * Creates a new MessageFilterList instance using the specified properties.
         * @param [properties] Properties to set
         * @returns MessageFilterList instance
         */
        public static create(properties?: meerkat.IMessageFilterList): meerkat.MessageFilterList;

        /**
         * Encodes the specified MessageFilterList message. Does not implicitly {@link meerkat.MessageFilterList.verify|verify} messages.
         * @param message MessageFilterList message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IMessageFilterList, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified MessageFilterList message, length delimited. Does not implicitly {@link meerkat.MessageFilterList.verify|verify} messages.
         * @param message MessageFilterList message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IMessageFilterList, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a MessageFilterList message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns MessageFilterList
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.MessageFilterList;

        /**
         * Decodes a MessageFilterList message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns MessageFilterList
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.MessageFilterList;

        /**
         * Verifies a MessageFilterList message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a MessageFilterList message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns MessageFilterList
         */
        public static fromObject(object: { [k: string]: any }): meerkat.MessageFilterList;

        /**
         * Creates a plain object from a MessageFilterList message. Also converts values to other types if specified.
         * @param message MessageFilterList
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.MessageFilterList, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this MessageFilterList to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a BeginBatchMessage. */
    interface IBeginBatchMessage {

        /** BeginBatchMessage tag */
        tag?: string[];
    }

    /** Represents a BeginBatchMessage. */
    class BeginBatchMessage {

        /**
         * Constructs a new BeginBatchMessage.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IBeginBatchMessage);

        /** BeginBatchMessage tag. */
        public tag: string[];

        /**
         * Creates a new BeginBatchMessage instance using the specified properties.
         * @param [properties] Properties to set
         * @returns BeginBatchMessage instance
         */
        public static create(properties?: meerkat.IBeginBatchMessage): meerkat.BeginBatchMessage;

        /**
         * Encodes the specified BeginBatchMessage message. Does not implicitly {@link meerkat.BeginBatchMessage.verify|verify} messages.
         * @param message BeginBatchMessage message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IBeginBatchMessage, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified BeginBatchMessage message, length delimited. Does not implicitly {@link meerkat.BeginBatchMessage.verify|verify} messages.
         * @param message BeginBatchMessage message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IBeginBatchMessage, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a BeginBatchMessage message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns BeginBatchMessage
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.BeginBatchMessage;

        /**
         * Decodes a BeginBatchMessage message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns BeginBatchMessage
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.BeginBatchMessage;

        /**
         * Verifies a BeginBatchMessage message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a BeginBatchMessage message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns BeginBatchMessage
         */
        public static fromObject(object: { [k: string]: any }): meerkat.BeginBatchMessage;

        /**
         * Creates a plain object from a BeginBatchMessage message. Also converts values to other types if specified.
         * @param message BeginBatchMessage
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.BeginBatchMessage, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this BeginBatchMessage to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a CloseBatchMessage. */
    interface ICloseBatchMessage {

        /** CloseBatchMessage batchId */
        batchId?: (number|Long);

        /** CloseBatchMessage batchLength */
        batchLength?: number;

        /** CloseBatchMessage timestamp */
        timestamp?: google.protobuf.ITimestamp;

        /** CloseBatchMessage sig */
        sig?: meerkat.ISignature[];
    }

    /** Represents a CloseBatchMessage. */
    class CloseBatchMessage {

        /**
         * Constructs a new CloseBatchMessage.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.ICloseBatchMessage);

        /** CloseBatchMessage batchId. */
        public batchId: (number|Long);

        /** CloseBatchMessage batchLength. */
        public batchLength: number;

        /** CloseBatchMessage timestamp. */
        public timestamp?: (google.protobuf.ITimestamp|null);

        /** CloseBatchMessage sig. */
        public sig: meerkat.ISignature[];

        /**
         * Creates a new CloseBatchMessage instance using the specified properties.
         * @param [properties] Properties to set
         * @returns CloseBatchMessage instance
         */
        public static create(properties?: meerkat.ICloseBatchMessage): meerkat.CloseBatchMessage;

        /**
         * Encodes the specified CloseBatchMessage message. Does not implicitly {@link meerkat.CloseBatchMessage.verify|verify} messages.
         * @param message CloseBatchMessage message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.ICloseBatchMessage, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified CloseBatchMessage message, length delimited. Does not implicitly {@link meerkat.CloseBatchMessage.verify|verify} messages.
         * @param message CloseBatchMessage message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.ICloseBatchMessage, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a CloseBatchMessage message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns CloseBatchMessage
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.CloseBatchMessage;

        /**
         * Decodes a CloseBatchMessage message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns CloseBatchMessage
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.CloseBatchMessage;

        /**
         * Verifies a CloseBatchMessage message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a CloseBatchMessage message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns CloseBatchMessage
         */
        public static fromObject(object: { [k: string]: any }): meerkat.CloseBatchMessage;

        /**
         * Creates a plain object from a CloseBatchMessage message. Also converts values to other types if specified.
         * @param message CloseBatchMessage
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.CloseBatchMessage, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this CloseBatchMessage to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a BatchChunk. */
    interface IBatchChunk {

        /** BatchChunk data */
        data?: Uint8Array;
    }

    /** Represents a BatchChunk. */
    class BatchChunk {

        /**
         * Constructs a new BatchChunk.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IBatchChunk);

        /** BatchChunk data. */
        public data: Uint8Array;

        /**
         * Creates a new BatchChunk instance using the specified properties.
         * @param [properties] Properties to set
         * @returns BatchChunk instance
         */
        public static create(properties?: meerkat.IBatchChunk): meerkat.BatchChunk;

        /**
         * Encodes the specified BatchChunk message. Does not implicitly {@link meerkat.BatchChunk.verify|verify} messages.
         * @param message BatchChunk message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IBatchChunk, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified BatchChunk message, length delimited. Does not implicitly {@link meerkat.BatchChunk.verify|verify} messages.
         * @param message BatchChunk message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IBatchChunk, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a BatchChunk message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns BatchChunk
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.BatchChunk;

        /**
         * Decodes a BatchChunk message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns BatchChunk
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.BatchChunk;

        /**
         * Verifies a BatchChunk message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a BatchChunk message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns BatchChunk
         */
        public static fromObject(object: { [k: string]: any }): meerkat.BatchChunk;

        /**
         * Creates a plain object from a BatchChunk message. Also converts values to other types if specified.
         * @param message BatchChunk
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.BatchChunk, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this BatchChunk to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a BatchChunkList. */
    interface IBatchChunkList {

        /** BatchChunkList data */
        data?: meerkat.IBatchChunk[];
    }

    /** Represents a BatchChunkList. */
    class BatchChunkList {

        /**
         * Constructs a new BatchChunkList.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IBatchChunkList);

        /** BatchChunkList data. */
        public data: meerkat.IBatchChunk[];

        /**
         * Creates a new BatchChunkList instance using the specified properties.
         * @param [properties] Properties to set
         * @returns BatchChunkList instance
         */
        public static create(properties?: meerkat.IBatchChunkList): meerkat.BatchChunkList;

        /**
         * Encodes the specified BatchChunkList message. Does not implicitly {@link meerkat.BatchChunkList.verify|verify} messages.
         * @param message BatchChunkList message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IBatchChunkList, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified BatchChunkList message, length delimited. Does not implicitly {@link meerkat.BatchChunkList.verify|verify} messages.
         * @param message BatchChunkList message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IBatchChunkList, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a BatchChunkList message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns BatchChunkList
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.BatchChunkList;

        /**
         * Decodes a BatchChunkList message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns BatchChunkList
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.BatchChunkList;

        /**
         * Verifies a BatchChunkList message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a BatchChunkList message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns BatchChunkList
         */
        public static fromObject(object: { [k: string]: any }): meerkat.BatchChunkList;

        /**
         * Creates a plain object from a BatchChunkList message. Also converts values to other types if specified.
         * @param message BatchChunkList
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.BatchChunkList, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this BatchChunkList to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a BatchMessage. */
    interface IBatchMessage {

        /** BatchMessage batchId */
        batchId?: (number|Long);

        /** BatchMessage serialNum */
        serialNum?: number;

        /** BatchMessage data */
        data?: meerkat.IBatchChunk;
    }

    /** Represents a BatchMessage. */
    class BatchMessage {

        /**
         * Constructs a new BatchMessage.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IBatchMessage);

        /** BatchMessage batchId. */
        public batchId: (number|Long);

        /** BatchMessage serialNum. */
        public serialNum: number;

        /** BatchMessage data. */
        public data?: (meerkat.IBatchChunk|null);

        /**
         * Creates a new BatchMessage instance using the specified properties.
         * @param [properties] Properties to set
         * @returns BatchMessage instance
         */
        public static create(properties?: meerkat.IBatchMessage): meerkat.BatchMessage;

        /**
         * Encodes the specified BatchMessage message. Does not implicitly {@link meerkat.BatchMessage.verify|verify} messages.
         * @param message BatchMessage message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IBatchMessage, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified BatchMessage message, length delimited. Does not implicitly {@link meerkat.BatchMessage.verify|verify} messages.
         * @param message BatchMessage message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IBatchMessage, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a BatchMessage message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns BatchMessage
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.BatchMessage;

        /**
         * Decodes a BatchMessage message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns BatchMessage
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.BatchMessage;

        /**
         * Verifies a BatchMessage message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a BatchMessage message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns BatchMessage
         */
        public static fromObject(object: { [k: string]: any }): meerkat.BatchMessage;

        /**
         * Creates a plain object from a BatchMessage message. Also converts values to other types if specified.
         * @param message BatchMessage
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.BatchMessage, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this BatchMessage to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a SingleSyncQuery. */
    interface ISingleSyncQuery {

        /** SingleSyncQuery timeOfSync */
        timeOfSync?: google.protobuf.ITimestamp;

        /** SingleSyncQuery checksum */
        checksum?: (number|Long);
    }

    /** Represents a SingleSyncQuery. */
    class SingleSyncQuery {

        /**
         * Constructs a new SingleSyncQuery.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.ISingleSyncQuery);

        /** SingleSyncQuery timeOfSync. */
        public timeOfSync?: (google.protobuf.ITimestamp|null);

        /** SingleSyncQuery checksum. */
        public checksum: (number|Long);

        /**
         * Creates a new SingleSyncQuery instance using the specified properties.
         * @param [properties] Properties to set
         * @returns SingleSyncQuery instance
         */
        public static create(properties?: meerkat.ISingleSyncQuery): meerkat.SingleSyncQuery;

        /**
         * Encodes the specified SingleSyncQuery message. Does not implicitly {@link meerkat.SingleSyncQuery.verify|verify} messages.
         * @param message SingleSyncQuery message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.ISingleSyncQuery, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified SingleSyncQuery message, length delimited. Does not implicitly {@link meerkat.SingleSyncQuery.verify|verify} messages.
         * @param message SingleSyncQuery message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.ISingleSyncQuery, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a SingleSyncQuery message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns SingleSyncQuery
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.SingleSyncQuery;

        /**
         * Decodes a SingleSyncQuery message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns SingleSyncQuery
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.SingleSyncQuery;

        /**
         * Verifies a SingleSyncQuery message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a SingleSyncQuery message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns SingleSyncQuery
         */
        public static fromObject(object: { [k: string]: any }): meerkat.SingleSyncQuery;

        /**
         * Creates a plain object from a SingleSyncQuery message. Also converts values to other types if specified.
         * @param message SingleSyncQuery
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.SingleSyncQuery, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this SingleSyncQuery to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a SyncQuery. */
    interface ISyncQuery {

        /** SyncQuery filterList */
        filterList?: meerkat.IMessageFilterList;

        /** SyncQuery query */
        query?: meerkat.ISingleSyncQuery[];
    }

    /** Represents a SyncQuery. */
    class SyncQuery {

        /**
         * Constructs a new SyncQuery.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.ISyncQuery);

        /** SyncQuery filterList. */
        public filterList?: (meerkat.IMessageFilterList|null);

        /** SyncQuery query. */
        public query: meerkat.ISingleSyncQuery[];

        /**
         * Creates a new SyncQuery instance using the specified properties.
         * @param [properties] Properties to set
         * @returns SyncQuery instance
         */
        public static create(properties?: meerkat.ISyncQuery): meerkat.SyncQuery;

        /**
         * Encodes the specified SyncQuery message. Does not implicitly {@link meerkat.SyncQuery.verify|verify} messages.
         * @param message SyncQuery message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.ISyncQuery, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified SyncQuery message, length delimited. Does not implicitly {@link meerkat.SyncQuery.verify|verify} messages.
         * @param message SyncQuery message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.ISyncQuery, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a SyncQuery message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns SyncQuery
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.SyncQuery;

        /**
         * Decodes a SyncQuery message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns SyncQuery
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.SyncQuery;

        /**
         * Verifies a SyncQuery message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a SyncQuery message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns SyncQuery
         */
        public static fromObject(object: { [k: string]: any }): meerkat.SyncQuery;

        /**
         * Creates a plain object from a SyncQuery message. Also converts values to other types if specified.
         * @param message SyncQuery
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.SyncQuery, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this SyncQuery to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a GenerateSyncQueryParams. */
    interface IGenerateSyncQueryParams {

        /** GenerateSyncQueryParams filterList */
        filterList?: meerkat.IMessageFilterList;

        /** GenerateSyncQueryParams breakpointList */
        breakpointList?: number[];
    }

    /** Represents a GenerateSyncQueryParams. */
    class GenerateSyncQueryParams {

        /**
         * Constructs a new GenerateSyncQueryParams.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IGenerateSyncQueryParams);

        /** GenerateSyncQueryParams filterList. */
        public filterList?: (meerkat.IMessageFilterList|null);

        /** GenerateSyncQueryParams breakpointList. */
        public breakpointList: number[];

        /**
         * Creates a new GenerateSyncQueryParams instance using the specified properties.
         * @param [properties] Properties to set
         * @returns GenerateSyncQueryParams instance
         */
        public static create(properties?: meerkat.IGenerateSyncQueryParams): meerkat.GenerateSyncQueryParams;

        /**
         * Encodes the specified GenerateSyncQueryParams message. Does not implicitly {@link meerkat.GenerateSyncQueryParams.verify|verify} messages.
         * @param message GenerateSyncQueryParams message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IGenerateSyncQueryParams, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified GenerateSyncQueryParams message, length delimited. Does not implicitly {@link meerkat.GenerateSyncQueryParams.verify|verify} messages.
         * @param message GenerateSyncQueryParams message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IGenerateSyncQueryParams, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a GenerateSyncQueryParams message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns GenerateSyncQueryParams
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.GenerateSyncQueryParams;

        /**
         * Decodes a GenerateSyncQueryParams message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns GenerateSyncQueryParams
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.GenerateSyncQueryParams;

        /**
         * Verifies a GenerateSyncQueryParams message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a GenerateSyncQueryParams message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns GenerateSyncQueryParams
         */
        public static fromObject(object: { [k: string]: any }): meerkat.GenerateSyncQueryParams;

        /**
         * Creates a plain object from a GenerateSyncQueryParams message. Also converts values to other types if specified.
         * @param message GenerateSyncQueryParams
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.GenerateSyncQueryParams, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this GenerateSyncQueryParams to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a SyncQueryResponse. */
    interface ISyncQueryResponse {

        /** SyncQueryResponse lastEntryNum */
        lastEntryNum?: (number|Long);

        /** SyncQueryResponse lastTimeOfSync */
        lastTimeOfSync?: google.protobuf.ITimestamp;
    }

    /** Represents a SyncQueryResponse. */
    class SyncQueryResponse {

        /**
         * Constructs a new SyncQueryResponse.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.ISyncQueryResponse);

        /** SyncQueryResponse lastEntryNum. */
        public lastEntryNum: (number|Long);

        /** SyncQueryResponse lastTimeOfSync. */
        public lastTimeOfSync?: (google.protobuf.ITimestamp|null);

        /**
         * Creates a new SyncQueryResponse instance using the specified properties.
         * @param [properties] Properties to set
         * @returns SyncQueryResponse instance
         */
        public static create(properties?: meerkat.ISyncQueryResponse): meerkat.SyncQueryResponse;

        /**
         * Encodes the specified SyncQueryResponse message. Does not implicitly {@link meerkat.SyncQueryResponse.verify|verify} messages.
         * @param message SyncQueryResponse message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.ISyncQueryResponse, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified SyncQueryResponse message, length delimited. Does not implicitly {@link meerkat.SyncQueryResponse.verify|verify} messages.
         * @param message SyncQueryResponse message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.ISyncQueryResponse, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a SyncQueryResponse message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns SyncQueryResponse
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.SyncQueryResponse;

        /**
         * Decodes a SyncQueryResponse message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns SyncQueryResponse
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.SyncQueryResponse;

        /**
         * Verifies a SyncQueryResponse message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a SyncQueryResponse message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns SyncQueryResponse
         */
        public static fromObject(object: { [k: string]: any }): meerkat.SyncQueryResponse;

        /**
         * Creates a plain object from a SyncQueryResponse message. Also converts values to other types if specified.
         * @param message SyncQueryResponse
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.SyncQueryResponse, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this SyncQueryResponse to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a BatchQuery. */
    interface IBatchQuery {

        /** BatchQuery msgID */
        msgID?: meerkat.IMessageID;

        /** BatchQuery startPosition */
        startPosition?: number;
    }

    /** Represents a BatchQuery. */
    class BatchQuery {

        /**
         * Constructs a new BatchQuery.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IBatchQuery);

        /** BatchQuery msgID. */
        public msgID?: (meerkat.IMessageID|null);

        /** BatchQuery startPosition. */
        public startPosition: number;

        /**
         * Creates a new BatchQuery instance using the specified properties.
         * @param [properties] Properties to set
         * @returns BatchQuery instance
         */
        public static create(properties?: meerkat.IBatchQuery): meerkat.BatchQuery;

        /**
         * Encodes the specified BatchQuery message. Does not implicitly {@link meerkat.BatchQuery.verify|verify} messages.
         * @param message BatchQuery message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IBatchQuery, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified BatchQuery message, length delimited. Does not implicitly {@link meerkat.BatchQuery.verify|verify} messages.
         * @param message BatchQuery message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IBatchQuery, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a BatchQuery message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns BatchQuery
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.BatchQuery;

        /**
         * Decodes a BatchQuery message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns BatchQuery
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.BatchQuery;

        /**
         * Verifies a BatchQuery message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a BatchQuery message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns BatchQuery
         */
        public static fromObject(object: { [k: string]: any }): meerkat.BatchQuery;

        /**
         * Creates a plain object from a BatchQuery message. Also converts values to other types if specified.
         * @param message BatchQuery
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.BatchQuery, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this BatchQuery to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a ServerStatus. */
    interface IServerStatus {

        /** ServerStatus mode */
        mode?: meerkat.ServerStatus.Mode;

        /** ServerStatus name */
        name?: string;

        /** ServerStatus pk */
        pk?: meerkat.ISignatureVerificationKey;
    }

    /** Represents a ServerStatus. */
    class ServerStatus {

        /**
         * Constructs a new ServerStatus.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IServerStatus);

        /** ServerStatus mode. */
        public mode: meerkat.ServerStatus.Mode;

        /** ServerStatus name. */
        public name: string;

        /** ServerStatus pk. */
        public pk?: (meerkat.ISignatureVerificationKey|null);

        /**
         * Creates a new ServerStatus instance using the specified properties.
         * @param [properties] Properties to set
         * @returns ServerStatus instance
         */
        public static create(properties?: meerkat.IServerStatus): meerkat.ServerStatus;

        /**
         * Encodes the specified ServerStatus message. Does not implicitly {@link meerkat.ServerStatus.verify|verify} messages.
         * @param message ServerStatus message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IServerStatus, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified ServerStatus message, length delimited. Does not implicitly {@link meerkat.ServerStatus.verify|verify} messages.
         * @param message ServerStatus message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IServerStatus, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a ServerStatus message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns ServerStatus
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.ServerStatus;

        /**
         * Decodes a ServerStatus message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns ServerStatus
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.ServerStatus;

        /**
         * Verifies a ServerStatus message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a ServerStatus message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns ServerStatus
         */
        public static fromObject(object: { [k: string]: any }): meerkat.ServerStatus;

        /**
         * Creates a plain object from a ServerStatus message. Also converts values to other types if specified.
         * @param message ServerStatus
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.ServerStatus, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this ServerStatus to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    namespace ServerStatus {

        /** Mode enum. */
        enum Mode {
            MODE_SETUP_AUTH = 0,
            MODE_SETUP_DB = 1,
            MODE_RUNNING = 2
        }
    }

    /** Properties of a BroadcastMessage. */
    interface IBroadcastMessage {

        /** BroadcastMessage sender */
        sender?: number;

        /** BroadcastMessage destination */
        destination?: number;

        /** BroadcastMessage isPrivate */
        isPrivate?: boolean;

        /** BroadcastMessage payload */
        payload?: Uint8Array;
    }

    /** Represents a BroadcastMessage. */
    class BroadcastMessage {

        /**
         * Constructs a new BroadcastMessage.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IBroadcastMessage);

        /** BroadcastMessage sender. */
        public sender: number;

        /** BroadcastMessage destination. */
        public destination: number;

        /** BroadcastMessage isPrivate. */
        public isPrivate: boolean;

        /** BroadcastMessage payload. */
        public payload: Uint8Array;

        /**
         * Creates a new BroadcastMessage instance using the specified properties.
         * @param [properties] Properties to set
         * @returns BroadcastMessage instance
         */
        public static create(properties?: meerkat.IBroadcastMessage): meerkat.BroadcastMessage;

        /**
         * Encodes the specified BroadcastMessage message. Does not implicitly {@link meerkat.BroadcastMessage.verify|verify} messages.
         * @param message BroadcastMessage message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IBroadcastMessage, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified BroadcastMessage message, length delimited. Does not implicitly {@link meerkat.BroadcastMessage.verify|verify} messages.
         * @param message BroadcastMessage message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IBroadcastMessage, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a BroadcastMessage message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns BroadcastMessage
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.BroadcastMessage;

        /**
         * Decodes a BroadcastMessage message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns BroadcastMessage
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.BroadcastMessage;

        /**
         * Verifies a BroadcastMessage message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a BroadcastMessage message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns BroadcastMessage
         */
        public static fromObject(object: { [k: string]: any }): meerkat.BroadcastMessage;

        /**
         * Creates a plain object from a BroadcastMessage message. Also converts values to other types if specified.
         * @param message BroadcastMessage
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.BroadcastMessage, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this BroadcastMessage to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of an ElGamalPublicKey. */
    interface IElGamalPublicKey {

        /** ElGamalPublicKey subjectPublicKeyInfo */
        subjectPublicKeyInfo?: Uint8Array;
    }

    /** Represents an ElGamalPublicKey. */
    class ElGamalPublicKey {

        /**
         * Constructs a new ElGamalPublicKey.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IElGamalPublicKey);

        /** ElGamalPublicKey subjectPublicKeyInfo. */
        public subjectPublicKeyInfo: Uint8Array;

        /**
         * Creates a new ElGamalPublicKey instance using the specified properties.
         * @param [properties] Properties to set
         * @returns ElGamalPublicKey instance
         */
        public static create(properties?: meerkat.IElGamalPublicKey): meerkat.ElGamalPublicKey;

        /**
         * Encodes the specified ElGamalPublicKey message. Does not implicitly {@link meerkat.ElGamalPublicKey.verify|verify} messages.
         * @param message ElGamalPublicKey message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IElGamalPublicKey, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified ElGamalPublicKey message, length delimited. Does not implicitly {@link meerkat.ElGamalPublicKey.verify|verify} messages.
         * @param message ElGamalPublicKey message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IElGamalPublicKey, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes an ElGamalPublicKey message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns ElGamalPublicKey
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.ElGamalPublicKey;

        /**
         * Decodes an ElGamalPublicKey message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns ElGamalPublicKey
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.ElGamalPublicKey;

        /**
         * Verifies an ElGamalPublicKey message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates an ElGamalPublicKey message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns ElGamalPublicKey
         */
        public static fromObject(object: { [k: string]: any }): meerkat.ElGamalPublicKey;

        /**
         * Creates a plain object from an ElGamalPublicKey message. Also converts values to other types if specified.
         * @param message ElGamalPublicKey
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.ElGamalPublicKey, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this ElGamalPublicKey to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a GroupElement. */
    interface IGroupElement {

        /** GroupElement data */
        data?: Uint8Array;
    }

    /** Represents a GroupElement. */
    class GroupElement {

        /**
         * Constructs a new GroupElement.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IGroupElement);

        /** GroupElement data. */
        public data: Uint8Array;

        /**
         * Creates a new GroupElement instance using the specified properties.
         * @param [properties] Properties to set
         * @returns GroupElement instance
         */
        public static create(properties?: meerkat.IGroupElement): meerkat.GroupElement;

        /**
         * Encodes the specified GroupElement message. Does not implicitly {@link meerkat.GroupElement.verify|verify} messages.
         * @param message GroupElement message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IGroupElement, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified GroupElement message, length delimited. Does not implicitly {@link meerkat.GroupElement.verify|verify} messages.
         * @param message GroupElement message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IGroupElement, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a GroupElement message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns GroupElement
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.GroupElement;

        /**
         * Decodes a GroupElement message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns GroupElement
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.GroupElement;

        /**
         * Verifies a GroupElement message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a GroupElement message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns GroupElement
         */
        public static fromObject(object: { [k: string]: any }): meerkat.GroupElement;

        /**
         * Creates a plain object from a GroupElement message. Also converts values to other types if specified.
         * @param message GroupElement
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.GroupElement, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this GroupElement to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of an ElGamalCiphertext. */
    interface IElGamalCiphertext {

        /** ElGamalCiphertext c1 */
        c1?: meerkat.IGroupElement;

        /** ElGamalCiphertext c2 */
        c2?: meerkat.IGroupElement;
    }

    /** Represents an ElGamalCiphertext. */
    class ElGamalCiphertext {

        /**
         * Constructs a new ElGamalCiphertext.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IElGamalCiphertext);

        /** ElGamalCiphertext c1. */
        public c1?: (meerkat.IGroupElement|null);

        /** ElGamalCiphertext c2. */
        public c2?: (meerkat.IGroupElement|null);

        /**
         * Creates a new ElGamalCiphertext instance using the specified properties.
         * @param [properties] Properties to set
         * @returns ElGamalCiphertext instance
         */
        public static create(properties?: meerkat.IElGamalCiphertext): meerkat.ElGamalCiphertext;

        /**
         * Encodes the specified ElGamalCiphertext message. Does not implicitly {@link meerkat.ElGamalCiphertext.verify|verify} messages.
         * @param message ElGamalCiphertext message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IElGamalCiphertext, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified ElGamalCiphertext message, length delimited. Does not implicitly {@link meerkat.ElGamalCiphertext.verify|verify} messages.
         * @param message ElGamalCiphertext message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IElGamalCiphertext, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes an ElGamalCiphertext message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns ElGamalCiphertext
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.ElGamalCiphertext;

        /**
         * Decodes an ElGamalCiphertext message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns ElGamalCiphertext
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.ElGamalCiphertext;

        /**
         * Verifies an ElGamalCiphertext message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates an ElGamalCiphertext message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns ElGamalCiphertext
         */
        public static fromObject(object: { [k: string]: any }): meerkat.ElGamalCiphertext;

        /**
         * Creates a plain object from an ElGamalCiphertext message. Also converts values to other types if specified.
         * @param message ElGamalCiphertext
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.ElGamalCiphertext, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this ElGamalCiphertext to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** SignatureType enum. */
    enum SignatureType {
        ECDSA = 0,
        DSA = 1,
        RSA = 2
    }

    /** Properties of a BigInteger. */
    interface IBigInteger {

        /** BigInteger data */
        data?: Uint8Array;
    }

    /** Represents a BigInteger. */
    class BigInteger {

        /**
         * Constructs a new BigInteger.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IBigInteger);

        /** BigInteger data. */
        public data: Uint8Array;

        /**
         * Creates a new BigInteger instance using the specified properties.
         * @param [properties] Properties to set
         * @returns BigInteger instance
         */
        public static create(properties?: meerkat.IBigInteger): meerkat.BigInteger;

        /**
         * Encodes the specified BigInteger message. Does not implicitly {@link meerkat.BigInteger.verify|verify} messages.
         * @param message BigInteger message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IBigInteger, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified BigInteger message, length delimited. Does not implicitly {@link meerkat.BigInteger.verify|verify} messages.
         * @param message BigInteger message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IBigInteger, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a BigInteger message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns BigInteger
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.BigInteger;

        /**
         * Decodes a BigInteger message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns BigInteger
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.BigInteger;

        /**
         * Verifies a BigInteger message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a BigInteger message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns BigInteger
         */
        public static fromObject(object: { [k: string]: any }): meerkat.BigInteger;

        /**
         * Creates a plain object from a BigInteger message. Also converts values to other types if specified.
         * @param message BigInteger
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.BigInteger, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this BigInteger to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a Signature. */
    interface ISignature {

        /** Signature type */
        type?: meerkat.SignatureType;

        /** Signature data */
        data?: Uint8Array;

        /** Signature signerId */
        signerId?: Uint8Array;
    }

    /** Represents a Signature. */
    class Signature {

        /**
         * Constructs a new Signature.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.ISignature);

        /** Signature type. */
        public type: meerkat.SignatureType;

        /** Signature data. */
        public data: Uint8Array;

        /** Signature signerId. */
        public signerId: Uint8Array;

        /**
         * Creates a new Signature instance using the specified properties.
         * @param [properties] Properties to set
         * @returns Signature instance
         */
        public static create(properties?: meerkat.ISignature): meerkat.Signature;

        /**
         * Encodes the specified Signature message. Does not implicitly {@link meerkat.Signature.verify|verify} messages.
         * @param message Signature message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.ISignature, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified Signature message, length delimited. Does not implicitly {@link meerkat.Signature.verify|verify} messages.
         * @param message Signature message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.ISignature, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a Signature message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns Signature
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.Signature;

        /**
         * Decodes a Signature message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns Signature
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.Signature;

        /**
         * Verifies a Signature message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a Signature message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns Signature
         */
        public static fromObject(object: { [k: string]: any }): meerkat.Signature;

        /**
         * Creates a plain object from a Signature message. Also converts values to other types if specified.
         * @param message Signature
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.Signature, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this Signature to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a SignatureVerificationKey. */
    interface ISignatureVerificationKey {

        /** SignatureVerificationKey type */
        type?: meerkat.SignatureType;

        /** SignatureVerificationKey data */
        data?: Uint8Array;
    }

    /** Represents a SignatureVerificationKey. */
    class SignatureVerificationKey {

        /**
         * Constructs a new SignatureVerificationKey.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.ISignatureVerificationKey);

        /** SignatureVerificationKey type. */
        public type: meerkat.SignatureType;

        /** SignatureVerificationKey data. */
        public data: Uint8Array;

        /**
         * Creates a new SignatureVerificationKey instance using the specified properties.
         * @param [properties] Properties to set
         * @returns SignatureVerificationKey instance
         */
        public static create(properties?: meerkat.ISignatureVerificationKey): meerkat.SignatureVerificationKey;

        /**
         * Encodes the specified SignatureVerificationKey message. Does not implicitly {@link meerkat.SignatureVerificationKey.verify|verify} messages.
         * @param message SignatureVerificationKey message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.ISignatureVerificationKey, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified SignatureVerificationKey message, length delimited. Does not implicitly {@link meerkat.SignatureVerificationKey.verify|verify} messages.
         * @param message SignatureVerificationKey message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.ISignatureVerificationKey, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a SignatureVerificationKey message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns SignatureVerificationKey
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.SignatureVerificationKey;

        /**
         * Decodes a SignatureVerificationKey message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns SignatureVerificationKey
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.SignatureVerificationKey;

        /**
         * Verifies a SignatureVerificationKey message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a SignatureVerificationKey message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns SignatureVerificationKey
         */
        public static fromObject(object: { [k: string]: any }): meerkat.SignatureVerificationKey;

        /**
         * Creates a plain object from a SignatureVerificationKey message. Also converts values to other types if specified.
         * @param message SignatureVerificationKey
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.SignatureVerificationKey, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this SignatureVerificationKey to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of an EncryptionPublicKey. */
    interface IEncryptionPublicKey {

        /** EncryptionPublicKey data */
        data?: Uint8Array;
    }

    /** Represents an EncryptionPublicKey. */
    class EncryptionPublicKey {

        /**
         * Constructs a new EncryptionPublicKey.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IEncryptionPublicKey);

        /** EncryptionPublicKey data. */
        public data: Uint8Array;

        /**
         * Creates a new EncryptionPublicKey instance using the specified properties.
         * @param [properties] Properties to set
         * @returns EncryptionPublicKey instance
         */
        public static create(properties?: meerkat.IEncryptionPublicKey): meerkat.EncryptionPublicKey;

        /**
         * Encodes the specified EncryptionPublicKey message. Does not implicitly {@link meerkat.EncryptionPublicKey.verify|verify} messages.
         * @param message EncryptionPublicKey message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IEncryptionPublicKey, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified EncryptionPublicKey message, length delimited. Does not implicitly {@link meerkat.EncryptionPublicKey.verify|verify} messages.
         * @param message EncryptionPublicKey message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IEncryptionPublicKey, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes an EncryptionPublicKey message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns EncryptionPublicKey
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.EncryptionPublicKey;

        /**
         * Decodes an EncryptionPublicKey message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns EncryptionPublicKey
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.EncryptionPublicKey;

        /**
         * Verifies an EncryptionPublicKey message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates an EncryptionPublicKey message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns EncryptionPublicKey
         */
        public static fromObject(object: { [k: string]: any }): meerkat.EncryptionPublicKey;

        /**
         * Creates a plain object from an EncryptionPublicKey message. Also converts values to other types if specified.
         * @param message EncryptionPublicKey
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.EncryptionPublicKey, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this EncryptionPublicKey to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of an EncryptionRandomness. */
    interface IEncryptionRandomness {

        /** EncryptionRandomness data */
        data?: Uint8Array;
    }

    /** Represents an EncryptionRandomness. */
    class EncryptionRandomness {

        /**
         * Constructs a new EncryptionRandomness.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IEncryptionRandomness);

        /** EncryptionRandomness data. */
        public data: Uint8Array;

        /**
         * Creates a new EncryptionRandomness instance using the specified properties.
         * @param [properties] Properties to set
         * @returns EncryptionRandomness instance
         */
        public static create(properties?: meerkat.IEncryptionRandomness): meerkat.EncryptionRandomness;

        /**
         * Encodes the specified EncryptionRandomness message. Does not implicitly {@link meerkat.EncryptionRandomness.verify|verify} messages.
         * @param message EncryptionRandomness message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IEncryptionRandomness, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified EncryptionRandomness message, length delimited. Does not implicitly {@link meerkat.EncryptionRandomness.verify|verify} messages.
         * @param message EncryptionRandomness message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IEncryptionRandomness, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes an EncryptionRandomness message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns EncryptionRandomness
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.EncryptionRandomness;

        /**
         * Decodes an EncryptionRandomness message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns EncryptionRandomness
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.EncryptionRandomness;

        /**
         * Verifies an EncryptionRandomness message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates an EncryptionRandomness message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns EncryptionRandomness
         */
        public static fromObject(object: { [k: string]: any }): meerkat.EncryptionRandomness;

        /**
         * Creates a plain object from an EncryptionRandomness message. Also converts values to other types if specified.
         * @param message EncryptionRandomness
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.EncryptionRandomness, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this EncryptionRandomness to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a RandomnessGenerationProof. */
    interface IRandomnessGenerationProof {

        /** RandomnessGenerationProof data */
        data?: Uint8Array;
    }

    /** Represents a RandomnessGenerationProof. */
    class RandomnessGenerationProof {

        /**
         * Constructs a new RandomnessGenerationProof.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IRandomnessGenerationProof);

        /** RandomnessGenerationProof data. */
        public data: Uint8Array;

        /**
         * Creates a new RandomnessGenerationProof instance using the specified properties.
         * @param [properties] Properties to set
         * @returns RandomnessGenerationProof instance
         */
        public static create(properties?: meerkat.IRandomnessGenerationProof): meerkat.RandomnessGenerationProof;

        /**
         * Encodes the specified RandomnessGenerationProof message. Does not implicitly {@link meerkat.RandomnessGenerationProof.verify|verify} messages.
         * @param message RandomnessGenerationProof message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IRandomnessGenerationProof, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified RandomnessGenerationProof message, length delimited. Does not implicitly {@link meerkat.RandomnessGenerationProof.verify|verify} messages.
         * @param message RandomnessGenerationProof message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IRandomnessGenerationProof, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a RandomnessGenerationProof message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns RandomnessGenerationProof
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.RandomnessGenerationProof;

        /**
         * Decodes a RandomnessGenerationProof message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns RandomnessGenerationProof
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.RandomnessGenerationProof;

        /**
         * Verifies a RandomnessGenerationProof message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a RandomnessGenerationProof message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns RandomnessGenerationProof
         */
        public static fromObject(object: { [k: string]: any }): meerkat.RandomnessGenerationProof;

        /**
         * Creates a plain object from a RandomnessGenerationProof message. Also converts values to other types if specified.
         * @param message RandomnessGenerationProof
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.RandomnessGenerationProof, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this RandomnessGenerationProof to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a RerandomizableEncryptedMessage. */
    interface IRerandomizableEncryptedMessage {

        /** RerandomizableEncryptedMessage data */
        data?: Uint8Array;
    }

    /** Represents a RerandomizableEncryptedMessage. */
    class RerandomizableEncryptedMessage {

        /**
         * Constructs a new RerandomizableEncryptedMessage.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IRerandomizableEncryptedMessage);

        /** RerandomizableEncryptedMessage data. */
        public data: Uint8Array;

        /**
         * Creates a new RerandomizableEncryptedMessage instance using the specified properties.
         * @param [properties] Properties to set
         * @returns RerandomizableEncryptedMessage instance
         */
        public static create(properties?: meerkat.IRerandomizableEncryptedMessage): meerkat.RerandomizableEncryptedMessage;

        /**
         * Encodes the specified RerandomizableEncryptedMessage message. Does not implicitly {@link meerkat.RerandomizableEncryptedMessage.verify|verify} messages.
         * @param message RerandomizableEncryptedMessage message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IRerandomizableEncryptedMessage, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified RerandomizableEncryptedMessage message, length delimited. Does not implicitly {@link meerkat.RerandomizableEncryptedMessage.verify|verify} messages.
         * @param message RerandomizableEncryptedMessage message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IRerandomizableEncryptedMessage, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a RerandomizableEncryptedMessage message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns RerandomizableEncryptedMessage
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.RerandomizableEncryptedMessage;

        /**
         * Decodes a RerandomizableEncryptedMessage message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns RerandomizableEncryptedMessage
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.RerandomizableEncryptedMessage;

        /**
         * Verifies a RerandomizableEncryptedMessage message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a RerandomizableEncryptedMessage message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns RerandomizableEncryptedMessage
         */
        public static fromObject(object: { [k: string]: any }): meerkat.RerandomizableEncryptedMessage;

        /**
         * Creates a plain object from a RerandomizableEncryptedMessage message. Also converts values to other types if specified.
         * @param message RerandomizableEncryptedMessage
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.RerandomizableEncryptedMessage, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this RerandomizableEncryptedMessage to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a Payload. */
    interface IPayload {

        /** Payload type */
        type?: meerkat.Payload.Type;

        /** Payload id */
        id?: meerkat.IIDMessage;

        /** Payload share */
        share?: meerkat.IShareMessage;

        /** Payload commitment */
        commitment?: meerkat.ICommitmentMessage;
    }

    /** Represents a Payload. */
    class Payload {

        /**
         * Constructs a new Payload.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IPayload);

        /** Payload type. */
        public type: meerkat.Payload.Type;

        /** Payload id. */
        public id?: (meerkat.IIDMessage|null);

        /** Payload share. */
        public share?: (meerkat.IShareMessage|null);

        /** Payload commitment. */
        public commitment?: (meerkat.ICommitmentMessage|null);

        /** Payload payloadData. */
        public payloadData?: string;

        /**
         * Creates a new Payload instance using the specified properties.
         * @param [properties] Properties to set
         * @returns Payload instance
         */
        public static create(properties?: meerkat.IPayload): meerkat.Payload;

        /**
         * Encodes the specified Payload message. Does not implicitly {@link meerkat.Payload.verify|verify} messages.
         * @param message Payload message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IPayload, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified Payload message, length delimited. Does not implicitly {@link meerkat.Payload.verify|verify} messages.
         * @param message Payload message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IPayload, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a Payload message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns Payload
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.Payload;

        /**
         * Decodes a Payload message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns Payload
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.Payload;

        /**
         * Verifies a Payload message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a Payload message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns Payload
         */
        public static fromObject(object: { [k: string]: any }): meerkat.Payload;

        /**
         * Creates a plain object from a Payload message. Also converts values to other types if specified.
         * @param message Payload
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.Payload, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this Payload to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    namespace Payload {

        /** Type enum. */
        enum Type {
            SHARE = 0,
            COMMITMENT = 1,
            COMPLAINT = 2,
            DONE = 3,
            ANSWER = 4,
            YCOMMITMENT = 5,
            YCOMPLAINT = 6,
            YANSWER = 7,
            ABORT = 8
        }
    }

    /** Properties of a IDMessage. */
    interface IIDMessage {

        /** IDMessage id */
        id?: number;
    }

    /** Represents a IDMessage. */
    class IDMessage {

        /**
         * Constructs a new IDMessage.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IIDMessage);

        /** IDMessage id. */
        public id: number;

        /**
         * Creates a new IDMessage instance using the specified properties.
         * @param [properties] Properties to set
         * @returns IDMessage instance
         */
        public static create(properties?: meerkat.IIDMessage): meerkat.IDMessage;

        /**
         * Encodes the specified IDMessage message. Does not implicitly {@link meerkat.IDMessage.verify|verify} messages.
         * @param message IDMessage message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IIDMessage, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified IDMessage message, length delimited. Does not implicitly {@link meerkat.IDMessage.verify|verify} messages.
         * @param message IDMessage message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IIDMessage, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a IDMessage message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns IDMessage
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.IDMessage;

        /**
         * Decodes a IDMessage message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns IDMessage
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.IDMessage;

        /**
         * Verifies a IDMessage message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a IDMessage message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns IDMessage
         */
        public static fromObject(object: { [k: string]: any }): meerkat.IDMessage;

        /**
         * Creates a plain object from a IDMessage message. Also converts values to other types if specified.
         * @param message IDMessage
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.IDMessage, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this IDMessage to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a ShareMessage. */
    interface IShareMessage {

        /** ShareMessage i */
        i?: number;

        /** ShareMessage j */
        j?: number;

        /** ShareMessage share */
        share?: Uint8Array;

        /** ShareMessage shareT */
        shareT?: Uint8Array;
    }

    /** Represents a ShareMessage. */
    class ShareMessage {

        /**
         * Constructs a new ShareMessage.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IShareMessage);

        /** ShareMessage i. */
        public i: number;

        /** ShareMessage j. */
        public j: number;

        /** ShareMessage share. */
        public share: Uint8Array;

        /** ShareMessage shareT. */
        public shareT: Uint8Array;

        /**
         * Creates a new ShareMessage instance using the specified properties.
         * @param [properties] Properties to set
         * @returns ShareMessage instance
         */
        public static create(properties?: meerkat.IShareMessage): meerkat.ShareMessage;

        /**
         * Encodes the specified ShareMessage message. Does not implicitly {@link meerkat.ShareMessage.verify|verify} messages.
         * @param message ShareMessage message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IShareMessage, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified ShareMessage message, length delimited. Does not implicitly {@link meerkat.ShareMessage.verify|verify} messages.
         * @param message ShareMessage message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IShareMessage, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a ShareMessage message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns ShareMessage
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.ShareMessage;

        /**
         * Decodes a ShareMessage message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns ShareMessage
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.ShareMessage;

        /**
         * Verifies a ShareMessage message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a ShareMessage message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns ShareMessage
         */
        public static fromObject(object: { [k: string]: any }): meerkat.ShareMessage;

        /**
         * Creates a plain object from a ShareMessage message. Also converts values to other types if specified.
         * @param message ShareMessage
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.ShareMessage, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this ShareMessage to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a CommitmentMessage. */
    interface ICommitmentMessage {

        /** CommitmentMessage k */
        k?: number;

        /** CommitmentMessage commitment */
        commitment?: Uint8Array;
    }

    /** Represents a CommitmentMessage. */
    class CommitmentMessage {

        /**
         * Constructs a new CommitmentMessage.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.ICommitmentMessage);

        /** CommitmentMessage k. */
        public k: number;

        /** CommitmentMessage commitment. */
        public commitment: Uint8Array;

        /**
         * Creates a new CommitmentMessage instance using the specified properties.
         * @param [properties] Properties to set
         * @returns CommitmentMessage instance
         */
        public static create(properties?: meerkat.ICommitmentMessage): meerkat.CommitmentMessage;

        /**
         * Encodes the specified CommitmentMessage message. Does not implicitly {@link meerkat.CommitmentMessage.verify|verify} messages.
         * @param message CommitmentMessage message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.ICommitmentMessage, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified CommitmentMessage message, length delimited. Does not implicitly {@link meerkat.CommitmentMessage.verify|verify} messages.
         * @param message CommitmentMessage message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.ICommitmentMessage, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a CommitmentMessage message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns CommitmentMessage
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.CommitmentMessage;

        /**
         * Decodes a CommitmentMessage message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns CommitmentMessage
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.CommitmentMessage;

        /**
         * Verifies a CommitmentMessage message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a CommitmentMessage message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns CommitmentMessage
         */
        public static fromObject(object: { [k: string]: any }): meerkat.CommitmentMessage;

        /**
         * Creates a plain object from a CommitmentMessage message. Also converts values to other types if specified.
         * @param message CommitmentMessage
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.CommitmentMessage, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this CommitmentMessage to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a MixBatchHeader. */
    interface IMixBatchHeader {

        /** MixBatchHeader logN */
        logN?: number;

        /** MixBatchHeader layers */
        layers?: number;
    }

    /** Represents a MixBatchHeader. */
    class MixBatchHeader {

        /**
         * Constructs a new MixBatchHeader.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IMixBatchHeader);

        /** MixBatchHeader logN. */
        public logN: number;

        /** MixBatchHeader layers. */
        public layers: number;

        /**
         * Creates a new MixBatchHeader instance using the specified properties.
         * @param [properties] Properties to set
         * @returns MixBatchHeader instance
         */
        public static create(properties?: meerkat.IMixBatchHeader): meerkat.MixBatchHeader;

        /**
         * Encodes the specified MixBatchHeader message. Does not implicitly {@link meerkat.MixBatchHeader.verify|verify} messages.
         * @param message MixBatchHeader message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IMixBatchHeader, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified MixBatchHeader message, length delimited. Does not implicitly {@link meerkat.MixBatchHeader.verify|verify} messages.
         * @param message MixBatchHeader message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IMixBatchHeader, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a MixBatchHeader message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns MixBatchHeader
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.MixBatchHeader;

        /**
         * Decodes a MixBatchHeader message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns MixBatchHeader
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.MixBatchHeader;

        /**
         * Verifies a MixBatchHeader message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a MixBatchHeader message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns MixBatchHeader
         */
        public static fromObject(object: { [k: string]: any }): meerkat.MixBatchHeader;

        /**
         * Creates a plain object from a MixBatchHeader message. Also converts values to other types if specified.
         * @param message MixBatchHeader
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.MixBatchHeader, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this MixBatchHeader to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a Plaintext. */
    interface IPlaintext {

        /** Plaintext data */
        data?: Uint8Array;
    }

    /** Represents a Plaintext. */
    class Plaintext {

        /**
         * Constructs a new Plaintext.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IPlaintext);

        /** Plaintext data. */
        public data: Uint8Array;

        /**
         * Creates a new Plaintext instance using the specified properties.
         * @param [properties] Properties to set
         * @returns Plaintext instance
         */
        public static create(properties?: meerkat.IPlaintext): meerkat.Plaintext;

        /**
         * Encodes the specified Plaintext message. Does not implicitly {@link meerkat.Plaintext.verify|verify} messages.
         * @param message Plaintext message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IPlaintext, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified Plaintext message, length delimited. Does not implicitly {@link meerkat.Plaintext.verify|verify} messages.
         * @param message Plaintext message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IPlaintext, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a Plaintext message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns Plaintext
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.Plaintext;

        /**
         * Decodes a Plaintext message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns Plaintext
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.Plaintext;

        /**
         * Verifies a Plaintext message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a Plaintext message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns Plaintext
         */
        public static fromObject(object: { [k: string]: any }): meerkat.Plaintext;

        /**
         * Creates a plain object from a Plaintext message. Also converts values to other types if specified.
         * @param message Plaintext
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.Plaintext, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this Plaintext to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a Mix2Proof. */
    interface IMix2Proof {

        /** Mix2Proof firstMessage */
        firstMessage?: meerkat.Mix2Proof.IFirstMessage;

        /** Mix2Proof finalMessage */
        finalMessage?: meerkat.Mix2Proof.IFinalMessage;

        /** Mix2Proof location */
        location?: meerkat.Mix2Proof.ILocation;
    }

    /** Represents a Mix2Proof. */
    class Mix2Proof {

        /**
         * Constructs a new Mix2Proof.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IMix2Proof);

        /** Mix2Proof firstMessage. */
        public firstMessage?: (meerkat.Mix2Proof.IFirstMessage|null);

        /** Mix2Proof finalMessage. */
        public finalMessage?: (meerkat.Mix2Proof.IFinalMessage|null);

        /** Mix2Proof location. */
        public location?: (meerkat.Mix2Proof.ILocation|null);

        /**
         * Creates a new Mix2Proof instance using the specified properties.
         * @param [properties] Properties to set
         * @returns Mix2Proof instance
         */
        public static create(properties?: meerkat.IMix2Proof): meerkat.Mix2Proof;

        /**
         * Encodes the specified Mix2Proof message. Does not implicitly {@link meerkat.Mix2Proof.verify|verify} messages.
         * @param message Mix2Proof message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IMix2Proof, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified Mix2Proof message, length delimited. Does not implicitly {@link meerkat.Mix2Proof.verify|verify} messages.
         * @param message Mix2Proof message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IMix2Proof, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a Mix2Proof message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns Mix2Proof
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.Mix2Proof;

        /**
         * Decodes a Mix2Proof message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns Mix2Proof
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.Mix2Proof;

        /**
         * Verifies a Mix2Proof message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a Mix2Proof message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns Mix2Proof
         */
        public static fromObject(object: { [k: string]: any }): meerkat.Mix2Proof;

        /**
         * Creates a plain object from a Mix2Proof message. Also converts values to other types if specified.
         * @param message Mix2Proof
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.Mix2Proof, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this Mix2Proof to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    namespace Mix2Proof {

        /** Properties of a DlogProof. */
        interface IDlogProof {
        }

        /** Represents a DlogProof. */
        class DlogProof {

            /**
             * Constructs a new DlogProof.
             * @param [properties] Properties to set
             */
            constructor(properties?: meerkat.Mix2Proof.IDlogProof);

            /**
             * Creates a new DlogProof instance using the specified properties.
             * @param [properties] Properties to set
             * @returns DlogProof instance
             */
            public static create(properties?: meerkat.Mix2Proof.IDlogProof): meerkat.Mix2Proof.DlogProof;

            /**
             * Encodes the specified DlogProof message. Does not implicitly {@link meerkat.Mix2Proof.DlogProof.verify|verify} messages.
             * @param message DlogProof message or plain object to encode
             * @param [writer] Writer to encode to
             * @returns Writer
             */
            public static encode(message: meerkat.Mix2Proof.IDlogProof, writer?: $protobuf.Writer): $protobuf.Writer;

            /**
             * Encodes the specified DlogProof message, length delimited. Does not implicitly {@link meerkat.Mix2Proof.DlogProof.verify|verify} messages.
             * @param message DlogProof message or plain object to encode
             * @param [writer] Writer to encode to
             * @returns Writer
             */
            public static encodeDelimited(message: meerkat.Mix2Proof.IDlogProof, writer?: $protobuf.Writer): $protobuf.Writer;

            /**
             * Decodes a DlogProof message from the specified reader or buffer.
             * @param reader Reader or buffer to decode from
             * @param [length] Message length if known beforehand
             * @returns DlogProof
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.Mix2Proof.DlogProof;

            /**
             * Decodes a DlogProof message from the specified reader or buffer, length delimited.
             * @param reader Reader or buffer to decode from
             * @returns DlogProof
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.Mix2Proof.DlogProof;

            /**
             * Verifies a DlogProof message.
             * @param message Plain object to verify
             * @returns `null` if valid, otherwise the reason why it is not
             */
            public static verify(message: { [k: string]: any }): (string|null);

            /**
             * Creates a DlogProof message from a plain object. Also converts values to their respective internal types.
             * @param object Plain object
             * @returns DlogProof
             */
            public static fromObject(object: { [k: string]: any }): meerkat.Mix2Proof.DlogProof;

            /**
             * Creates a plain object from a DlogProof message. Also converts values to other types if specified.
             * @param message DlogProof
             * @param [options] Conversion options
             * @returns Plain object
             */
            public static toObject(message: meerkat.Mix2Proof.DlogProof, options?: $protobuf.IConversionOptions): { [k: string]: any };

            /**
             * Converts this DlogProof to JSON.
             * @returns JSON object
             */
            public toJSON(): { [k: string]: any };
        }

        namespace DlogProof {

            /** Properties of a FirstMessage. */
            interface IFirstMessage {

                /** FirstMessage gr */
                gr?: meerkat.IGroupElement;

                /** FirstMessage hr */
                hr?: meerkat.IGroupElement;
            }

            /** Represents a FirstMessage. */
            class FirstMessage {

                /**
                 * Constructs a new FirstMessage.
                 * @param [properties] Properties to set
                 */
                constructor(properties?: meerkat.Mix2Proof.DlogProof.IFirstMessage);

                /** FirstMessage gr. */
                public gr?: (meerkat.IGroupElement|null);

                /** FirstMessage hr. */
                public hr?: (meerkat.IGroupElement|null);

                /**
                 * Creates a new FirstMessage instance using the specified properties.
                 * @param [properties] Properties to set
                 * @returns FirstMessage instance
                 */
                public static create(properties?: meerkat.Mix2Proof.DlogProof.IFirstMessage): meerkat.Mix2Proof.DlogProof.FirstMessage;

                /**
                 * Encodes the specified FirstMessage message. Does not implicitly {@link meerkat.Mix2Proof.DlogProof.FirstMessage.verify|verify} messages.
                 * @param message FirstMessage message or plain object to encode
                 * @param [writer] Writer to encode to
                 * @returns Writer
                 */
                public static encode(message: meerkat.Mix2Proof.DlogProof.IFirstMessage, writer?: $protobuf.Writer): $protobuf.Writer;

                /**
                 * Encodes the specified FirstMessage message, length delimited. Does not implicitly {@link meerkat.Mix2Proof.DlogProof.FirstMessage.verify|verify} messages.
                 * @param message FirstMessage message or plain object to encode
                 * @param [writer] Writer to encode to
                 * @returns Writer
                 */
                public static encodeDelimited(message: meerkat.Mix2Proof.DlogProof.IFirstMessage, writer?: $protobuf.Writer): $protobuf.Writer;

                /**
                 * Decodes a FirstMessage message from the specified reader or buffer.
                 * @param reader Reader or buffer to decode from
                 * @param [length] Message length if known beforehand
                 * @returns FirstMessage
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.Mix2Proof.DlogProof.FirstMessage;

                /**
                 * Decodes a FirstMessage message from the specified reader or buffer, length delimited.
                 * @param reader Reader or buffer to decode from
                 * @returns FirstMessage
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.Mix2Proof.DlogProof.FirstMessage;

                /**
                 * Verifies a FirstMessage message.
                 * @param message Plain object to verify
                 * @returns `null` if valid, otherwise the reason why it is not
                 */
                public static verify(message: { [k: string]: any }): (string|null);

                /**
                 * Creates a FirstMessage message from a plain object. Also converts values to their respective internal types.
                 * @param object Plain object
                 * @returns FirstMessage
                 */
                public static fromObject(object: { [k: string]: any }): meerkat.Mix2Proof.DlogProof.FirstMessage;

                /**
                 * Creates a plain object from a FirstMessage message. Also converts values to other types if specified.
                 * @param message FirstMessage
                 * @param [options] Conversion options
                 * @returns Plain object
                 */
                public static toObject(message: meerkat.Mix2Proof.DlogProof.FirstMessage, options?: $protobuf.IConversionOptions): { [k: string]: any };

                /**
                 * Converts this FirstMessage to JSON.
                 * @returns JSON object
                 */
                public toJSON(): { [k: string]: any };
            }

            /** Properties of a FinalMessage. */
            interface IFinalMessage {

                /** FinalMessage xcr */
                xcr?: meerkat.IBigInteger;
            }

            /** Represents a FinalMessage. */
            class FinalMessage {

                /**
                 * Constructs a new FinalMessage.
                 * @param [properties] Properties to set
                 */
                constructor(properties?: meerkat.Mix2Proof.DlogProof.IFinalMessage);

                /** FinalMessage xcr. */
                public xcr?: (meerkat.IBigInteger|null);

                /**
                 * Creates a new FinalMessage instance using the specified properties.
                 * @param [properties] Properties to set
                 * @returns FinalMessage instance
                 */
                public static create(properties?: meerkat.Mix2Proof.DlogProof.IFinalMessage): meerkat.Mix2Proof.DlogProof.FinalMessage;

                /**
                 * Encodes the specified FinalMessage message. Does not implicitly {@link meerkat.Mix2Proof.DlogProof.FinalMessage.verify|verify} messages.
                 * @param message FinalMessage message or plain object to encode
                 * @param [writer] Writer to encode to
                 * @returns Writer
                 */
                public static encode(message: meerkat.Mix2Proof.DlogProof.IFinalMessage, writer?: $protobuf.Writer): $protobuf.Writer;

                /**
                 * Encodes the specified FinalMessage message, length delimited. Does not implicitly {@link meerkat.Mix2Proof.DlogProof.FinalMessage.verify|verify} messages.
                 * @param message FinalMessage message or plain object to encode
                 * @param [writer] Writer to encode to
                 * @returns Writer
                 */
                public static encodeDelimited(message: meerkat.Mix2Proof.DlogProof.IFinalMessage, writer?: $protobuf.Writer): $protobuf.Writer;

                /**
                 * Decodes a FinalMessage message from the specified reader or buffer.
                 * @param reader Reader or buffer to decode from
                 * @param [length] Message length if known beforehand
                 * @returns FinalMessage
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.Mix2Proof.DlogProof.FinalMessage;

                /**
                 * Decodes a FinalMessage message from the specified reader or buffer, length delimited.
                 * @param reader Reader or buffer to decode from
                 * @returns FinalMessage
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.Mix2Proof.DlogProof.FinalMessage;

                /**
                 * Verifies a FinalMessage message.
                 * @param message Plain object to verify
                 * @returns `null` if valid, otherwise the reason why it is not
                 */
                public static verify(message: { [k: string]: any }): (string|null);

                /**
                 * Creates a FinalMessage message from a plain object. Also converts values to their respective internal types.
                 * @param object Plain object
                 * @returns FinalMessage
                 */
                public static fromObject(object: { [k: string]: any }): meerkat.Mix2Proof.DlogProof.FinalMessage;

                /**
                 * Creates a plain object from a FinalMessage message. Also converts values to other types if specified.
                 * @param message FinalMessage
                 * @param [options] Conversion options
                 * @returns Plain object
                 */
                public static toObject(message: meerkat.Mix2Proof.DlogProof.FinalMessage, options?: $protobuf.IConversionOptions): { [k: string]: any };

                /**
                 * Converts this FinalMessage to JSON.
                 * @returns JSON object
                 */
                public toJSON(): { [k: string]: any };
            }
        }

        /** Properties of an AndProof. */
        interface IAndProof {
        }

        /** Represents an AndProof. */
        class AndProof {

            /**
             * Constructs a new AndProof.
             * @param [properties] Properties to set
             */
            constructor(properties?: meerkat.Mix2Proof.IAndProof);

            /**
             * Creates a new AndProof instance using the specified properties.
             * @param [properties] Properties to set
             * @returns AndProof instance
             */
            public static create(properties?: meerkat.Mix2Proof.IAndProof): meerkat.Mix2Proof.AndProof;

            /**
             * Encodes the specified AndProof message. Does not implicitly {@link meerkat.Mix2Proof.AndProof.verify|verify} messages.
             * @param message AndProof message or plain object to encode
             * @param [writer] Writer to encode to
             * @returns Writer
             */
            public static encode(message: meerkat.Mix2Proof.IAndProof, writer?: $protobuf.Writer): $protobuf.Writer;

            /**
             * Encodes the specified AndProof message, length delimited. Does not implicitly {@link meerkat.Mix2Proof.AndProof.verify|verify} messages.
             * @param message AndProof message or plain object to encode
             * @param [writer] Writer to encode to
             * @returns Writer
             */
            public static encodeDelimited(message: meerkat.Mix2Proof.IAndProof, writer?: $protobuf.Writer): $protobuf.Writer;

            /**
             * Decodes an AndProof message from the specified reader or buffer.
             * @param reader Reader or buffer to decode from
             * @param [length] Message length if known beforehand
             * @returns AndProof
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.Mix2Proof.AndProof;

            /**
             * Decodes an AndProof message from the specified reader or buffer, length delimited.
             * @param reader Reader or buffer to decode from
             * @returns AndProof
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.Mix2Proof.AndProof;

            /**
             * Verifies an AndProof message.
             * @param message Plain object to verify
             * @returns `null` if valid, otherwise the reason why it is not
             */
            public static verify(message: { [k: string]: any }): (string|null);

            /**
             * Creates an AndProof message from a plain object. Also converts values to their respective internal types.
             * @param object Plain object
             * @returns AndProof
             */
            public static fromObject(object: { [k: string]: any }): meerkat.Mix2Proof.AndProof;

            /**
             * Creates a plain object from an AndProof message. Also converts values to other types if specified.
             * @param message AndProof
             * @param [options] Conversion options
             * @returns Plain object
             */
            public static toObject(message: meerkat.Mix2Proof.AndProof, options?: $protobuf.IConversionOptions): { [k: string]: any };

            /**
             * Converts this AndProof to JSON.
             * @returns JSON object
             */
            public toJSON(): { [k: string]: any };
        }

        namespace AndProof {

            /** Properties of a FirstMessage. */
            interface IFirstMessage {

                /** FirstMessage clause0 */
                clause0?: meerkat.Mix2Proof.DlogProof.IFirstMessage;

                /** FirstMessage clause1 */
                clause1?: meerkat.Mix2Proof.DlogProof.IFirstMessage;
            }

            /** Represents a FirstMessage. */
            class FirstMessage {

                /**
                 * Constructs a new FirstMessage.
                 * @param [properties] Properties to set
                 */
                constructor(properties?: meerkat.Mix2Proof.AndProof.IFirstMessage);

                /** FirstMessage clause0. */
                public clause0?: (meerkat.Mix2Proof.DlogProof.IFirstMessage|null);

                /** FirstMessage clause1. */
                public clause1?: (meerkat.Mix2Proof.DlogProof.IFirstMessage|null);

                /**
                 * Creates a new FirstMessage instance using the specified properties.
                 * @param [properties] Properties to set
                 * @returns FirstMessage instance
                 */
                public static create(properties?: meerkat.Mix2Proof.AndProof.IFirstMessage): meerkat.Mix2Proof.AndProof.FirstMessage;

                /**
                 * Encodes the specified FirstMessage message. Does not implicitly {@link meerkat.Mix2Proof.AndProof.FirstMessage.verify|verify} messages.
                 * @param message FirstMessage message or plain object to encode
                 * @param [writer] Writer to encode to
                 * @returns Writer
                 */
                public static encode(message: meerkat.Mix2Proof.AndProof.IFirstMessage, writer?: $protobuf.Writer): $protobuf.Writer;

                /**
                 * Encodes the specified FirstMessage message, length delimited. Does not implicitly {@link meerkat.Mix2Proof.AndProof.FirstMessage.verify|verify} messages.
                 * @param message FirstMessage message or plain object to encode
                 * @param [writer] Writer to encode to
                 * @returns Writer
                 */
                public static encodeDelimited(message: meerkat.Mix2Proof.AndProof.IFirstMessage, writer?: $protobuf.Writer): $protobuf.Writer;

                /**
                 * Decodes a FirstMessage message from the specified reader or buffer.
                 * @param reader Reader or buffer to decode from
                 * @param [length] Message length if known beforehand
                 * @returns FirstMessage
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.Mix2Proof.AndProof.FirstMessage;

                /**
                 * Decodes a FirstMessage message from the specified reader or buffer, length delimited.
                 * @param reader Reader or buffer to decode from
                 * @returns FirstMessage
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.Mix2Proof.AndProof.FirstMessage;

                /**
                 * Verifies a FirstMessage message.
                 * @param message Plain object to verify
                 * @returns `null` if valid, otherwise the reason why it is not
                 */
                public static verify(message: { [k: string]: any }): (string|null);

                /**
                 * Creates a FirstMessage message from a plain object. Also converts values to their respective internal types.
                 * @param object Plain object
                 * @returns FirstMessage
                 */
                public static fromObject(object: { [k: string]: any }): meerkat.Mix2Proof.AndProof.FirstMessage;

                /**
                 * Creates a plain object from a FirstMessage message. Also converts values to other types if specified.
                 * @param message FirstMessage
                 * @param [options] Conversion options
                 * @returns Plain object
                 */
                public static toObject(message: meerkat.Mix2Proof.AndProof.FirstMessage, options?: $protobuf.IConversionOptions): { [k: string]: any };

                /**
                 * Converts this FirstMessage to JSON.
                 * @returns JSON object
                 */
                public toJSON(): { [k: string]: any };
            }

            /** Properties of a FinalMessage. */
            interface IFinalMessage {

                /** FinalMessage clause0 */
                clause0?: meerkat.Mix2Proof.DlogProof.IFinalMessage;

                /** FinalMessage clause1 */
                clause1?: meerkat.Mix2Proof.DlogProof.IFinalMessage;
            }

            /** Represents a FinalMessage. */
            class FinalMessage {

                /**
                 * Constructs a new FinalMessage.
                 * @param [properties] Properties to set
                 */
                constructor(properties?: meerkat.Mix2Proof.AndProof.IFinalMessage);

                /** FinalMessage clause0. */
                public clause0?: (meerkat.Mix2Proof.DlogProof.IFinalMessage|null);

                /** FinalMessage clause1. */
                public clause1?: (meerkat.Mix2Proof.DlogProof.IFinalMessage|null);

                /**
                 * Creates a new FinalMessage instance using the specified properties.
                 * @param [properties] Properties to set
                 * @returns FinalMessage instance
                 */
                public static create(properties?: meerkat.Mix2Proof.AndProof.IFinalMessage): meerkat.Mix2Proof.AndProof.FinalMessage;

                /**
                 * Encodes the specified FinalMessage message. Does not implicitly {@link meerkat.Mix2Proof.AndProof.FinalMessage.verify|verify} messages.
                 * @param message FinalMessage message or plain object to encode
                 * @param [writer] Writer to encode to
                 * @returns Writer
                 */
                public static encode(message: meerkat.Mix2Proof.AndProof.IFinalMessage, writer?: $protobuf.Writer): $protobuf.Writer;

                /**
                 * Encodes the specified FinalMessage message, length delimited. Does not implicitly {@link meerkat.Mix2Proof.AndProof.FinalMessage.verify|verify} messages.
                 * @param message FinalMessage message or plain object to encode
                 * @param [writer] Writer to encode to
                 * @returns Writer
                 */
                public static encodeDelimited(message: meerkat.Mix2Proof.AndProof.IFinalMessage, writer?: $protobuf.Writer): $protobuf.Writer;

                /**
                 * Decodes a FinalMessage message from the specified reader or buffer.
                 * @param reader Reader or buffer to decode from
                 * @param [length] Message length if known beforehand
                 * @returns FinalMessage
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.Mix2Proof.AndProof.FinalMessage;

                /**
                 * Decodes a FinalMessage message from the specified reader or buffer, length delimited.
                 * @param reader Reader or buffer to decode from
                 * @returns FinalMessage
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.Mix2Proof.AndProof.FinalMessage;

                /**
                 * Verifies a FinalMessage message.
                 * @param message Plain object to verify
                 * @returns `null` if valid, otherwise the reason why it is not
                 */
                public static verify(message: { [k: string]: any }): (string|null);

                /**
                 * Creates a FinalMessage message from a plain object. Also converts values to their respective internal types.
                 * @param object Plain object
                 * @returns FinalMessage
                 */
                public static fromObject(object: { [k: string]: any }): meerkat.Mix2Proof.AndProof.FinalMessage;

                /**
                 * Creates a plain object from a FinalMessage message. Also converts values to other types if specified.
                 * @param message FinalMessage
                 * @param [options] Conversion options
                 * @returns Plain object
                 */
                public static toObject(message: meerkat.Mix2Proof.AndProof.FinalMessage, options?: $protobuf.IConversionOptions): { [k: string]: any };

                /**
                 * Converts this FinalMessage to JSON.
                 * @returns JSON object
                 */
                public toJSON(): { [k: string]: any };
            }
        }

        /** Properties of a FirstMessage. */
        interface IFirstMessage {

            /** FirstMessage clause0 */
            clause0?: meerkat.Mix2Proof.AndProof.IFirstMessage;

            /** FirstMessage clause1 */
            clause1?: meerkat.Mix2Proof.AndProof.IFirstMessage;
        }

        /** Represents a FirstMessage. */
        class FirstMessage {

            /**
             * Constructs a new FirstMessage.
             * @param [properties] Properties to set
             */
            constructor(properties?: meerkat.Mix2Proof.IFirstMessage);

            /** FirstMessage clause0. */
            public clause0?: (meerkat.Mix2Proof.AndProof.IFirstMessage|null);

            /** FirstMessage clause1. */
            public clause1?: (meerkat.Mix2Proof.AndProof.IFirstMessage|null);

            /**
             * Creates a new FirstMessage instance using the specified properties.
             * @param [properties] Properties to set
             * @returns FirstMessage instance
             */
            public static create(properties?: meerkat.Mix2Proof.IFirstMessage): meerkat.Mix2Proof.FirstMessage;

            /**
             * Encodes the specified FirstMessage message. Does not implicitly {@link meerkat.Mix2Proof.FirstMessage.verify|verify} messages.
             * @param message FirstMessage message or plain object to encode
             * @param [writer] Writer to encode to
             * @returns Writer
             */
            public static encode(message: meerkat.Mix2Proof.IFirstMessage, writer?: $protobuf.Writer): $protobuf.Writer;

            /**
             * Encodes the specified FirstMessage message, length delimited. Does not implicitly {@link meerkat.Mix2Proof.FirstMessage.verify|verify} messages.
             * @param message FirstMessage message or plain object to encode
             * @param [writer] Writer to encode to
             * @returns Writer
             */
            public static encodeDelimited(message: meerkat.Mix2Proof.IFirstMessage, writer?: $protobuf.Writer): $protobuf.Writer;

            /**
             * Decodes a FirstMessage message from the specified reader or buffer.
             * @param reader Reader or buffer to decode from
             * @param [length] Message length if known beforehand
             * @returns FirstMessage
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.Mix2Proof.FirstMessage;

            /**
             * Decodes a FirstMessage message from the specified reader or buffer, length delimited.
             * @param reader Reader or buffer to decode from
             * @returns FirstMessage
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.Mix2Proof.FirstMessage;

            /**
             * Verifies a FirstMessage message.
             * @param message Plain object to verify
             * @returns `null` if valid, otherwise the reason why it is not
             */
            public static verify(message: { [k: string]: any }): (string|null);

            /**
             * Creates a FirstMessage message from a plain object. Also converts values to their respective internal types.
             * @param object Plain object
             * @returns FirstMessage
             */
            public static fromObject(object: { [k: string]: any }): meerkat.Mix2Proof.FirstMessage;

            /**
             * Creates a plain object from a FirstMessage message. Also converts values to other types if specified.
             * @param message FirstMessage
             * @param [options] Conversion options
             * @returns Plain object
             */
            public static toObject(message: meerkat.Mix2Proof.FirstMessage, options?: $protobuf.IConversionOptions): { [k: string]: any };

            /**
             * Converts this FirstMessage to JSON.
             * @returns JSON object
             */
            public toJSON(): { [k: string]: any };
        }

        /** Properties of a FinalMessage. */
        interface IFinalMessage {

            /** FinalMessage clause0 */
            clause0?: meerkat.Mix2Proof.AndProof.IFinalMessage;

            /** FinalMessage clause1 */
            clause1?: meerkat.Mix2Proof.AndProof.IFinalMessage;

            /** FinalMessage c0 */
            c0?: meerkat.IBigInteger;
        }

        /** Represents a FinalMessage. */
        class FinalMessage {

            /**
             * Constructs a new FinalMessage.
             * @param [properties] Properties to set
             */
            constructor(properties?: meerkat.Mix2Proof.IFinalMessage);

            /** FinalMessage clause0. */
            public clause0?: (meerkat.Mix2Proof.AndProof.IFinalMessage|null);

            /** FinalMessage clause1. */
            public clause1?: (meerkat.Mix2Proof.AndProof.IFinalMessage|null);

            /** FinalMessage c0. */
            public c0?: (meerkat.IBigInteger|null);

            /**
             * Creates a new FinalMessage instance using the specified properties.
             * @param [properties] Properties to set
             * @returns FinalMessage instance
             */
            public static create(properties?: meerkat.Mix2Proof.IFinalMessage): meerkat.Mix2Proof.FinalMessage;

            /**
             * Encodes the specified FinalMessage message. Does not implicitly {@link meerkat.Mix2Proof.FinalMessage.verify|verify} messages.
             * @param message FinalMessage message or plain object to encode
             * @param [writer] Writer to encode to
             * @returns Writer
             */
            public static encode(message: meerkat.Mix2Proof.IFinalMessage, writer?: $protobuf.Writer): $protobuf.Writer;

            /**
             * Encodes the specified FinalMessage message, length delimited. Does not implicitly {@link meerkat.Mix2Proof.FinalMessage.verify|verify} messages.
             * @param message FinalMessage message or plain object to encode
             * @param [writer] Writer to encode to
             * @returns Writer
             */
            public static encodeDelimited(message: meerkat.Mix2Proof.IFinalMessage, writer?: $protobuf.Writer): $protobuf.Writer;

            /**
             * Decodes a FinalMessage message from the specified reader or buffer.
             * @param reader Reader or buffer to decode from
             * @param [length] Message length if known beforehand
             * @returns FinalMessage
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.Mix2Proof.FinalMessage;

            /**
             * Decodes a FinalMessage message from the specified reader or buffer, length delimited.
             * @param reader Reader or buffer to decode from
             * @returns FinalMessage
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.Mix2Proof.FinalMessage;

            /**
             * Verifies a FinalMessage message.
             * @param message Plain object to verify
             * @returns `null` if valid, otherwise the reason why it is not
             */
            public static verify(message: { [k: string]: any }): (string|null);

            /**
             * Creates a FinalMessage message from a plain object. Also converts values to their respective internal types.
             * @param object Plain object
             * @returns FinalMessage
             */
            public static fromObject(object: { [k: string]: any }): meerkat.Mix2Proof.FinalMessage;

            /**
             * Creates a plain object from a FinalMessage message. Also converts values to other types if specified.
             * @param message FinalMessage
             * @param [options] Conversion options
             * @returns Plain object
             */
            public static toObject(message: meerkat.Mix2Proof.FinalMessage, options?: $protobuf.IConversionOptions): { [k: string]: any };

            /**
             * Converts this FinalMessage to JSON.
             * @returns JSON object
             */
            public toJSON(): { [k: string]: any };
        }

        /** Properties of a Location. */
        interface ILocation {

            /** Location layer */
            layer?: number;

            /** Location switchIdx */
            switchIdx?: number;

            /** Location out0 */
            out0?: number;

            /** Location out1 */
            out1?: number;
        }

        /** Represents a Location. */
        class Location {

            /**
             * Constructs a new Location.
             * @param [properties] Properties to set
             */
            constructor(properties?: meerkat.Mix2Proof.ILocation);

            /** Location layer. */
            public layer: number;

            /** Location switchIdx. */
            public switchIdx: number;

            /** Location out0. */
            public out0: number;

            /** Location out1. */
            public out1: number;

            /**
             * Creates a new Location instance using the specified properties.
             * @param [properties] Properties to set
             * @returns Location instance
             */
            public static create(properties?: meerkat.Mix2Proof.ILocation): meerkat.Mix2Proof.Location;

            /**
             * Encodes the specified Location message. Does not implicitly {@link meerkat.Mix2Proof.Location.verify|verify} messages.
             * @param message Location message or plain object to encode
             * @param [writer] Writer to encode to
             * @returns Writer
             */
            public static encode(message: meerkat.Mix2Proof.ILocation, writer?: $protobuf.Writer): $protobuf.Writer;

            /**
             * Encodes the specified Location message, length delimited. Does not implicitly {@link meerkat.Mix2Proof.Location.verify|verify} messages.
             * @param message Location message or plain object to encode
             * @param [writer] Writer to encode to
             * @returns Writer
             */
            public static encodeDelimited(message: meerkat.Mix2Proof.ILocation, writer?: $protobuf.Writer): $protobuf.Writer;

            /**
             * Decodes a Location message from the specified reader or buffer.
             * @param reader Reader or buffer to decode from
             * @param [length] Message length if known beforehand
             * @returns Location
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.Mix2Proof.Location;

            /**
             * Decodes a Location message from the specified reader or buffer, length delimited.
             * @param reader Reader or buffer to decode from
             * @returns Location
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.Mix2Proof.Location;

            /**
             * Verifies a Location message.
             * @param message Plain object to verify
             * @returns `null` if valid, otherwise the reason why it is not
             */
            public static verify(message: { [k: string]: any }): (string|null);

            /**
             * Creates a Location message from a plain object. Also converts values to their respective internal types.
             * @param object Plain object
             * @returns Location
             */
            public static fromObject(object: { [k: string]: any }): meerkat.Mix2Proof.Location;

            /**
             * Creates a plain object from a Location message. Also converts values to other types if specified.
             * @param message Location
             * @param [options] Conversion options
             * @returns Plain object
             */
            public static toObject(message: meerkat.Mix2Proof.Location, options?: $protobuf.IConversionOptions): { [k: string]: any };

            /**
             * Converts this Location to JSON.
             * @returns JSON object
             */
            public toJSON(): { [k: string]: any };
        }
    }

    /** Properties of a ConnectionServerData. */
    interface IConnectionServerData {

        /** ConnectionServerData serverUrl */
        serverUrl?: string;

        /** ConnectionServerData nonce */
        nonce?: (number|Long);
    }

    /** Represents a ConnectionServerData. */
    class ConnectionServerData {

        /**
         * Constructs a new ConnectionServerData.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IConnectionServerData);

        /** ConnectionServerData serverUrl. */
        public serverUrl: string;

        /** ConnectionServerData nonce. */
        public nonce: (number|Long);

        /**
         * Creates a new ConnectionServerData instance using the specified properties.
         * @param [properties] Properties to set
         * @returns ConnectionServerData instance
         */
        public static create(properties?: meerkat.IConnectionServerData): meerkat.ConnectionServerData;

        /**
         * Encodes the specified ConnectionServerData message. Does not implicitly {@link meerkat.ConnectionServerData.verify|verify} messages.
         * @param message ConnectionServerData message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IConnectionServerData, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified ConnectionServerData message, length delimited. Does not implicitly {@link meerkat.ConnectionServerData.verify|verify} messages.
         * @param message ConnectionServerData message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IConnectionServerData, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a ConnectionServerData message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns ConnectionServerData
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.ConnectionServerData;

        /**
         * Decodes a ConnectionServerData message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns ConnectionServerData
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.ConnectionServerData;

        /**
         * Verifies a ConnectionServerData message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a ConnectionServerData message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns ConnectionServerData
         */
        public static fromObject(object: { [k: string]: any }): meerkat.ConnectionServerData;

        /**
         * Creates a plain object from a ConnectionServerData message. Also converts values to other types if specified.
         * @param message ConnectionServerData
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.ConnectionServerData, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this ConnectionServerData to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a ConnectionClientData. */
    interface IConnectionClientData {

        /** ConnectionClientData scannerId */
        scannerId?: Uint8Array;

        /** ConnectionClientData scannerPK */
        scannerPK?: meerkat.ISignatureVerificationKey;

        /** ConnectionClientData nonce */
        nonce?: (number|Long);
    }

    /** Represents a ConnectionClientData. */
    class ConnectionClientData {

        /**
         * Constructs a new ConnectionClientData.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IConnectionClientData);

        /** ConnectionClientData scannerId. */
        public scannerId: Uint8Array;

        /** ConnectionClientData scannerPK. */
        public scannerPK?: (meerkat.ISignatureVerificationKey|null);

        /** ConnectionClientData nonce. */
        public nonce: (number|Long);

        /** ConnectionClientData id. */
        public id?: string;

        /**
         * Creates a new ConnectionClientData instance using the specified properties.
         * @param [properties] Properties to set
         * @returns ConnectionClientData instance
         */
        public static create(properties?: meerkat.IConnectionClientData): meerkat.ConnectionClientData;

        /**
         * Encodes the specified ConnectionClientData message. Does not implicitly {@link meerkat.ConnectionClientData.verify|verify} messages.
         * @param message ConnectionClientData message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IConnectionClientData, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified ConnectionClientData message, length delimited. Does not implicitly {@link meerkat.ConnectionClientData.verify|verify} messages.
         * @param message ConnectionClientData message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IConnectionClientData, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a ConnectionClientData message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns ConnectionClientData
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.ConnectionClientData;

        /**
         * Decodes a ConnectionClientData message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns ConnectionClientData
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.ConnectionClientData;

        /**
         * Verifies a ConnectionClientData message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a ConnectionClientData message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns ConnectionClientData
         */
        public static fromObject(object: { [k: string]: any }): meerkat.ConnectionClientData;

        /**
         * Creates a plain object from a ConnectionClientData message. Also converts values to other types if specified.
         * @param message ConnectionClientData
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.ConnectionClientData, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this ConnectionClientData to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a ScannedBallot. */
    interface IScannedBallot {

        /** ScannedBallot channel */
        channel?: Uint8Array;

        /** ScannedBallot signedEncryptedBallot */
        signedEncryptedBallot?: meerkat.ISignedEncryptedBallot;
    }

    /** Represents a ScannedBallot. */
    class ScannedBallot {

        /**
         * Constructs a new ScannedBallot.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IScannedBallot);

        /** ScannedBallot channel. */
        public channel: Uint8Array;

        /** ScannedBallot signedEncryptedBallot. */
        public signedEncryptedBallot?: (meerkat.ISignedEncryptedBallot|null);

        /**
         * Creates a new ScannedBallot instance using the specified properties.
         * @param [properties] Properties to set
         * @returns ScannedBallot instance
         */
        public static create(properties?: meerkat.IScannedBallot): meerkat.ScannedBallot;

        /**
         * Encodes the specified ScannedBallot message. Does not implicitly {@link meerkat.ScannedBallot.verify|verify} messages.
         * @param message ScannedBallot message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IScannedBallot, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified ScannedBallot message, length delimited. Does not implicitly {@link meerkat.ScannedBallot.verify|verify} messages.
         * @param message ScannedBallot message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IScannedBallot, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a ScannedBallot message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns ScannedBallot
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.ScannedBallot;

        /**
         * Decodes a ScannedBallot message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns ScannedBallot
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.ScannedBallot;

        /**
         * Verifies a ScannedBallot message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a ScannedBallot message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns ScannedBallot
         */
        public static fromObject(object: { [k: string]: any }): meerkat.ScannedBallot;

        /**
         * Creates a plain object from a ScannedBallot message. Also converts values to other types if specified.
         * @param message ScannedBallot
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.ScannedBallot, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this ScannedBallot to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a ScanError. */
    interface IScanError {

        /** ScanError msg */
        msg?: string;
    }

    /** Represents a ScanError. */
    class ScanError {

        /**
         * Constructs a new ScanError.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IScanError);

        /** ScanError msg. */
        public msg: string;

        /**
         * Creates a new ScanError instance using the specified properties.
         * @param [properties] Properties to set
         * @returns ScanError instance
         */
        public static create(properties?: meerkat.IScanError): meerkat.ScanError;

        /**
         * Encodes the specified ScanError message. Does not implicitly {@link meerkat.ScanError.verify|verify} messages.
         * @param message ScanError message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IScanError, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified ScanError message, length delimited. Does not implicitly {@link meerkat.ScanError.verify|verify} messages.
         * @param message ScanError message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IScanError, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a ScanError message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns ScanError
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.ScanError;

        /**
         * Decodes a ScanError message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns ScanError
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.ScanError;

        /**
         * Verifies a ScanError message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a ScanError message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns ScanError
         */
        public static fromObject(object: { [k: string]: any }): meerkat.ScanError;

        /**
         * Creates a plain object from a ScanError message. Also converts values to other types if specified.
         * @param message ScanError
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.ScanError, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this ScanError to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a ScannedData. */
    interface IScannedData {

        /** ScannedData ballot */
        ballot?: meerkat.IScannedBallot;

        /** ScannedData error */
        error?: meerkat.IScanError;

        /** ScannedData serial */
        serial?: (number|Long);

        /** ScannedData scannerId */
        scannerId?: Uint8Array;
    }

    /** Represents a ScannedData. */
    class ScannedData {

        /**
         * Constructs a new ScannedData.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IScannedData);

        /** ScannedData ballot. */
        public ballot?: (meerkat.IScannedBallot|null);

        /** ScannedData error. */
        public error?: (meerkat.IScanError|null);

        /** ScannedData serial. */
        public serial: (number|Long);

        /** ScannedData scannerId. */
        public scannerId: Uint8Array;

        /** ScannedData data. */
        public data?: string;

        /**
         * Creates a new ScannedData instance using the specified properties.
         * @param [properties] Properties to set
         * @returns ScannedData instance
         */
        public static create(properties?: meerkat.IScannedData): meerkat.ScannedData;

        /**
         * Encodes the specified ScannedData message. Does not implicitly {@link meerkat.ScannedData.verify|verify} messages.
         * @param message ScannedData message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IScannedData, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified ScannedData message, length delimited. Does not implicitly {@link meerkat.ScannedData.verify|verify} messages.
         * @param message ScannedData message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IScannedData, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a ScannedData message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns ScannedData
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.ScannedData;

        /**
         * Decodes a ScannedData message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns ScannedData
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.ScannedData;

        /**
         * Verifies a ScannedData message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a ScannedData message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns ScannedData
         */
        public static fromObject(object: { [k: string]: any }): meerkat.ScannedData;

        /**
         * Creates a plain object from a ScannedData message. Also converts values to other types if specified.
         * @param message ScannedData
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.ScannedData, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this ScannedData to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a SignedScannedData. */
    interface ISignedScannedData {

        /** SignedScannedData data */
        data?: meerkat.IScannedData;

        /** SignedScannedData scannerSig */
        scannerSig?: meerkat.ISignature;
    }

    /** Represents a SignedScannedData. */
    class SignedScannedData {

        /**
         * Constructs a new SignedScannedData.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.ISignedScannedData);

        /** SignedScannedData data. */
        public data?: (meerkat.IScannedData|null);

        /** SignedScannedData scannerSig. */
        public scannerSig?: (meerkat.ISignature|null);

        /**
         * Creates a new SignedScannedData instance using the specified properties.
         * @param [properties] Properties to set
         * @returns SignedScannedData instance
         */
        public static create(properties?: meerkat.ISignedScannedData): meerkat.SignedScannedData;

        /**
         * Encodes the specified SignedScannedData message. Does not implicitly {@link meerkat.SignedScannedData.verify|verify} messages.
         * @param message SignedScannedData message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.ISignedScannedData, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified SignedScannedData message, length delimited. Does not implicitly {@link meerkat.SignedScannedData.verify|verify} messages.
         * @param message SignedScannedData message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.ISignedScannedData, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a SignedScannedData message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns SignedScannedData
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.SignedScannedData;

        /**
         * Decodes a SignedScannedData message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns SignedScannedData
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.SignedScannedData;

        /**
         * Verifies a SignedScannedData message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a SignedScannedData message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns SignedScannedData
         */
        public static fromObject(object: { [k: string]: any }): meerkat.SignedScannedData;

        /**
         * Creates a plain object from a SignedScannedData message. Also converts values to other types if specified.
         * @param message SignedScannedData
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.SignedScannedData, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this SignedScannedData to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** UIElementDataType enum. */
    enum UIElementDataType {
        TEXT = 0,
        IMAGE = 1,
        VOICE = 2
    }

    /** QuestionType enum. */
    enum QuestionType {
        MULTIPLE_CHOICE = 0,
        MULTIPLE_SELECTION = 1,
        ORDER = 2
    }

    /** Properties of a UIElement. */
    interface IUIElement {

        /** UIElement type */
        type?: meerkat.UIElementDataType;

        /** UIElement data */
        data?: Uint8Array;
    }

    /** Represents a UIElement. */
    class UIElement {

        /**
         * Constructs a new UIElement.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IUIElement);

        /** UIElement type. */
        public type: meerkat.UIElementDataType;

        /** UIElement data. */
        public data: Uint8Array;

        /**
         * Creates a new UIElement instance using the specified properties.
         * @param [properties] Properties to set
         * @returns UIElement instance
         */
        public static create(properties?: meerkat.IUIElement): meerkat.UIElement;

        /**
         * Encodes the specified UIElement message. Does not implicitly {@link meerkat.UIElement.verify|verify} messages.
         * @param message UIElement message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IUIElement, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified UIElement message, length delimited. Does not implicitly {@link meerkat.UIElement.verify|verify} messages.
         * @param message UIElement message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IUIElement, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a UIElement message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns UIElement
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.UIElement;

        /**
         * Decodes a UIElement message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns UIElement
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.UIElement;

        /**
         * Verifies a UIElement message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a UIElement message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns UIElement
         */
        public static fromObject(object: { [k: string]: any }): meerkat.UIElement;

        /**
         * Creates a plain object from a UIElement message. Also converts values to other types if specified.
         * @param message UIElement
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.UIElement, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this UIElement to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a BallotQuestion. */
    interface IBallotQuestion {

        /** BallotQuestion isMandatory */
        isMandatory?: boolean;

        /** BallotQuestion question */
        question?: meerkat.IUIElement;

        /** BallotQuestion description */
        description?: meerkat.IUIElement;

        /** BallotQuestion answer */
        answer?: meerkat.IUIElement[];
    }

    /** Represents a BallotQuestion. */
    class BallotQuestion {

        /**
         * Constructs a new BallotQuestion.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IBallotQuestion);

        /** BallotQuestion isMandatory. */
        public isMandatory: boolean;

        /** BallotQuestion question. */
        public question?: (meerkat.IUIElement|null);

        /** BallotQuestion description. */
        public description?: (meerkat.IUIElement|null);

        /** BallotQuestion answer. */
        public answer: meerkat.IUIElement[];

        /**
         * Creates a new BallotQuestion instance using the specified properties.
         * @param [properties] Properties to set
         * @returns BallotQuestion instance
         */
        public static create(properties?: meerkat.IBallotQuestion): meerkat.BallotQuestion;

        /**
         * Encodes the specified BallotQuestion message. Does not implicitly {@link meerkat.BallotQuestion.verify|verify} messages.
         * @param message BallotQuestion message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IBallotQuestion, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified BallotQuestion message, length delimited. Does not implicitly {@link meerkat.BallotQuestion.verify|verify} messages.
         * @param message BallotQuestion message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IBallotQuestion, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a BallotQuestion message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns BallotQuestion
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.BallotQuestion;

        /**
         * Decodes a BallotQuestion message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns BallotQuestion
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.BallotQuestion;

        /**
         * Verifies a BallotQuestion message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a BallotQuestion message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns BallotQuestion
         */
        public static fromObject(object: { [k: string]: any }): meerkat.BallotQuestion;

        /**
         * Creates a plain object from a BallotQuestion message. Also converts values to other types if specified.
         * @param message BallotQuestion
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.BallotQuestion, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this BallotQuestion to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a QuestionCluster. */
    interface IQuestionCluster {

        /** QuestionCluster clusterDescription */
        clusterDescription?: meerkat.IUIElement;

        /** QuestionCluster questionIndex */
        questionIndex?: number[];
    }

    /** Represents a QuestionCluster. */
    class QuestionCluster {

        /**
         * Constructs a new QuestionCluster.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IQuestionCluster);

        /** QuestionCluster clusterDescription. */
        public clusterDescription?: (meerkat.IUIElement|null);

        /** QuestionCluster questionIndex. */
        public questionIndex: number[];

        /**
         * Creates a new QuestionCluster instance using the specified properties.
         * @param [properties] Properties to set
         * @returns QuestionCluster instance
         */
        public static create(properties?: meerkat.IQuestionCluster): meerkat.QuestionCluster;

        /**
         * Encodes the specified QuestionCluster message. Does not implicitly {@link meerkat.QuestionCluster.verify|verify} messages.
         * @param message QuestionCluster message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IQuestionCluster, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified QuestionCluster message, length delimited. Does not implicitly {@link meerkat.QuestionCluster.verify|verify} messages.
         * @param message QuestionCluster message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IQuestionCluster, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a QuestionCluster message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns QuestionCluster
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.QuestionCluster;

        /**
         * Decodes a QuestionCluster message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns QuestionCluster
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.QuestionCluster;

        /**
         * Verifies a QuestionCluster message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a QuestionCluster message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns QuestionCluster
         */
        public static fromObject(object: { [k: string]: any }): meerkat.QuestionCluster;

        /**
         * Creates a plain object from a QuestionCluster message. Also converts values to other types if specified.
         * @param message QuestionCluster
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.QuestionCluster, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this QuestionCluster to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a Channel. */
    interface IChannel {

        /** Channel channelDescription */
        channelDescription?: meerkat.IUIElement;

        /** Channel clusterIndex */
        clusterIndex?: number[];
    }

    /** Represents a Channel. */
    class Channel {

        /**
         * Constructs a new Channel.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IChannel);

        /** Channel channelDescription. */
        public channelDescription?: (meerkat.IUIElement|null);

        /** Channel clusterIndex. */
        public clusterIndex: number[];

        /**
         * Creates a new Channel instance using the specified properties.
         * @param [properties] Properties to set
         * @returns Channel instance
         */
        public static create(properties?: meerkat.IChannel): meerkat.Channel;

        /**
         * Encodes the specified Channel message. Does not implicitly {@link meerkat.Channel.verify|verify} messages.
         * @param message Channel message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IChannel, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified Channel message, length delimited. Does not implicitly {@link meerkat.Channel.verify|verify} messages.
         * @param message Channel message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IChannel, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a Channel message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns Channel
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.Channel;

        /**
         * Decodes a Channel message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns Channel
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.Channel;

        /**
         * Verifies a Channel message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a Channel message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns Channel
         */
        public static fromObject(object: { [k: string]: any }): meerkat.Channel;

        /**
         * Creates a plain object from a Channel message. Also converts values to other types if specified.
         * @param message Channel
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.Channel, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this Channel to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a BallotAnswer. */
    interface IBallotAnswer {

        /** BallotAnswer answer */
        answer?: (number|Long)[];
    }

    /** Represents a BallotAnswer. */
    class BallotAnswer {

        /**
         * Constructs a new BallotAnswer.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IBallotAnswer);

        /** BallotAnswer answer. */
        public answer: (number|Long)[];

        /**
         * Creates a new BallotAnswer instance using the specified properties.
         * @param [properties] Properties to set
         * @returns BallotAnswer instance
         */
        public static create(properties?: meerkat.IBallotAnswer): meerkat.BallotAnswer;

        /**
         * Encodes the specified BallotAnswer message. Does not implicitly {@link meerkat.BallotAnswer.verify|verify} messages.
         * @param message BallotAnswer message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IBallotAnswer, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified BallotAnswer message, length delimited. Does not implicitly {@link meerkat.BallotAnswer.verify|verify} messages.
         * @param message BallotAnswer message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IBallotAnswer, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a BallotAnswer message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns BallotAnswer
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.BallotAnswer;

        /**
         * Decodes a BallotAnswer message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns BallotAnswer
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.BallotAnswer;

        /**
         * Verifies a BallotAnswer message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a BallotAnswer message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns BallotAnswer
         */
        public static fromObject(object: { [k: string]: any }): meerkat.BallotAnswer;

        /**
         * Creates a plain object from a BallotAnswer message. Also converts values to other types if specified.
         * @param message BallotAnswer
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.BallotAnswer, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this BallotAnswer to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a PlaintextBallot. */
    interface IPlaintextBallot {

        /** PlaintextBallot serialNumber */
        serialNumber?: (number|Long);

        /** PlaintextBallot channelIdentifier */
        channelIdentifier?: Uint8Array;

        /** PlaintextBallot answers */
        answers?: meerkat.IBallotAnswer[];
    }

    /** Represents a PlaintextBallot. */
    class PlaintextBallot {

        /**
         * Constructs a new PlaintextBallot.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IPlaintextBallot);

        /** PlaintextBallot serialNumber. */
        public serialNumber: (number|Long);

        /** PlaintextBallot channelIdentifier. */
        public channelIdentifier: Uint8Array;

        /** PlaintextBallot answers. */
        public answers: meerkat.IBallotAnswer[];

        /**
         * Creates a new PlaintextBallot instance using the specified properties.
         * @param [properties] Properties to set
         * @returns PlaintextBallot instance
         */
        public static create(properties?: meerkat.IPlaintextBallot): meerkat.PlaintextBallot;

        /**
         * Encodes the specified PlaintextBallot message. Does not implicitly {@link meerkat.PlaintextBallot.verify|verify} messages.
         * @param message PlaintextBallot message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IPlaintextBallot, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified PlaintextBallot message, length delimited. Does not implicitly {@link meerkat.PlaintextBallot.verify|verify} messages.
         * @param message PlaintextBallot message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IPlaintextBallot, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a PlaintextBallot message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns PlaintextBallot
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.PlaintextBallot;

        /**
         * Decodes a PlaintextBallot message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns PlaintextBallot
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.PlaintextBallot;

        /**
         * Verifies a PlaintextBallot message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a PlaintextBallot message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns PlaintextBallot
         */
        public static fromObject(object: { [k: string]: any }): meerkat.PlaintextBallot;

        /**
         * Creates a plain object from a PlaintextBallot message. Also converts values to other types if specified.
         * @param message PlaintextBallot
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.PlaintextBallot, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this PlaintextBallot to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of an EncryptedBallot. */
    interface IEncryptedBallot {

        /** EncryptedBallot serialNumber */
        serialNumber?: (number|Long);

        /** EncryptedBallot data */
        data?: meerkat.IRerandomizableEncryptedMessage;
    }

    /** Represents an EncryptedBallot. */
    class EncryptedBallot {

        /**
         * Constructs a new EncryptedBallot.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IEncryptedBallot);

        /** EncryptedBallot serialNumber. */
        public serialNumber: (number|Long);

        /** EncryptedBallot data. */
        public data?: (meerkat.IRerandomizableEncryptedMessage|null);

        /**
         * Creates a new EncryptedBallot instance using the specified properties.
         * @param [properties] Properties to set
         * @returns EncryptedBallot instance
         */
        public static create(properties?: meerkat.IEncryptedBallot): meerkat.EncryptedBallot;

        /**
         * Encodes the specified EncryptedBallot message. Does not implicitly {@link meerkat.EncryptedBallot.verify|verify} messages.
         * @param message EncryptedBallot message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IEncryptedBallot, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified EncryptedBallot message, length delimited. Does not implicitly {@link meerkat.EncryptedBallot.verify|verify} messages.
         * @param message EncryptedBallot message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IEncryptedBallot, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes an EncryptedBallot message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns EncryptedBallot
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.EncryptedBallot;

        /**
         * Decodes an EncryptedBallot message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns EncryptedBallot
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.EncryptedBallot;

        /**
         * Verifies an EncryptedBallot message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates an EncryptedBallot message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns EncryptedBallot
         */
        public static fromObject(object: { [k: string]: any }): meerkat.EncryptedBallot;

        /**
         * Creates a plain object from an EncryptedBallot message. Also converts values to other types if specified.
         * @param message EncryptedBallot
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.EncryptedBallot, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this EncryptedBallot to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a SignedEncryptedBallot. */
    interface ISignedEncryptedBallot {

        /** SignedEncryptedBallot encryptedBallot */
        encryptedBallot?: meerkat.IEncryptedBallot;

        /** SignedEncryptedBallot signature */
        signature?: meerkat.ISignature;
    }

    /** Represents a SignedEncryptedBallot. */
    class SignedEncryptedBallot {

        /**
         * Constructs a new SignedEncryptedBallot.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.ISignedEncryptedBallot);

        /** SignedEncryptedBallot encryptedBallot. */
        public encryptedBallot?: (meerkat.IEncryptedBallot|null);

        /** SignedEncryptedBallot signature. */
        public signature?: (meerkat.ISignature|null);

        /**
         * Creates a new SignedEncryptedBallot instance using the specified properties.
         * @param [properties] Properties to set
         * @returns SignedEncryptedBallot instance
         */
        public static create(properties?: meerkat.ISignedEncryptedBallot): meerkat.SignedEncryptedBallot;

        /**
         * Encodes the specified SignedEncryptedBallot message. Does not implicitly {@link meerkat.SignedEncryptedBallot.verify|verify} messages.
         * @param message SignedEncryptedBallot message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.ISignedEncryptedBallot, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified SignedEncryptedBallot message, length delimited. Does not implicitly {@link meerkat.SignedEncryptedBallot.verify|verify} messages.
         * @param message SignedEncryptedBallot message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.ISignedEncryptedBallot, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a SignedEncryptedBallot message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns SignedEncryptedBallot
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.SignedEncryptedBallot;

        /**
         * Decodes a SignedEncryptedBallot message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns SignedEncryptedBallot
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.SignedEncryptedBallot;

        /**
         * Verifies a SignedEncryptedBallot message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a SignedEncryptedBallot message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns SignedEncryptedBallot
         */
        public static fromObject(object: { [k: string]: any }): meerkat.SignedEncryptedBallot;

        /**
         * Creates a plain object from a SignedEncryptedBallot message. Also converts values to other types if specified.
         * @param message SignedEncryptedBallot
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.SignedEncryptedBallot, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this SignedEncryptedBallot to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a BallotSecrets. */
    interface IBallotSecrets {

        /** BallotSecrets plaintextBallot */
        plaintextBallot?: meerkat.IPlaintextBallot;

        /** BallotSecrets encryptionRandomness */
        encryptionRandomness?: meerkat.IEncryptionRandomness;

        /** BallotSecrets proof */
        proof?: meerkat.IRandomnessGenerationProof;
    }

    /** Represents a BallotSecrets. */
    class BallotSecrets {

        /**
         * Constructs a new BallotSecrets.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IBallotSecrets);

        /** BallotSecrets plaintextBallot. */
        public plaintextBallot?: (meerkat.IPlaintextBallot|null);

        /** BallotSecrets encryptionRandomness. */
        public encryptionRandomness?: (meerkat.IEncryptionRandomness|null);

        /** BallotSecrets proof. */
        public proof?: (meerkat.IRandomnessGenerationProof|null);

        /**
         * Creates a new BallotSecrets instance using the specified properties.
         * @param [properties] Properties to set
         * @returns BallotSecrets instance
         */
        public static create(properties?: meerkat.IBallotSecrets): meerkat.BallotSecrets;

        /**
         * Encodes the specified BallotSecrets message. Does not implicitly {@link meerkat.BallotSecrets.verify|verify} messages.
         * @param message BallotSecrets message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IBallotSecrets, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified BallotSecrets message, length delimited. Does not implicitly {@link meerkat.BallotSecrets.verify|verify} messages.
         * @param message BallotSecrets message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IBallotSecrets, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a BallotSecrets message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns BallotSecrets
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.BallotSecrets;

        /**
         * Decodes a BallotSecrets message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns BallotSecrets
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.BallotSecrets;

        /**
         * Verifies a BallotSecrets message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a BallotSecrets message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns BallotSecrets
         */
        public static fromObject(object: { [k: string]: any }): meerkat.BallotSecrets;

        /**
         * Creates a plain object from a BallotSecrets message. Also converts values to other types if specified.
         * @param message BallotSecrets
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.BallotSecrets, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this BallotSecrets to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a BoothParams. */
    interface IBoothParams {

        /** BoothParams pscVerificationKeys */
        pscVerificationKeys?: meerkat.ISignatureVerificationKey[];
    }

    /** Represents a BoothParams. */
    class BoothParams {

        /**
         * Constructs a new BoothParams.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IBoothParams);

        /** BoothParams pscVerificationKeys. */
        public pscVerificationKeys: meerkat.ISignatureVerificationKey[];

        /**
         * Creates a new BoothParams instance using the specified properties.
         * @param [properties] Properties to set
         * @returns BoothParams instance
         */
        public static create(properties?: meerkat.IBoothParams): meerkat.BoothParams;

        /**
         * Encodes the specified BoothParams message. Does not implicitly {@link meerkat.BoothParams.verify|verify} messages.
         * @param message BoothParams message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IBoothParams, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified BoothParams message, length delimited. Does not implicitly {@link meerkat.BoothParams.verify|verify} messages.
         * @param message BoothParams message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IBoothParams, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a BoothParams message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns BoothParams
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.BoothParams;

        /**
         * Decodes a BoothParams message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns BoothParams
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.BoothParams;

        /**
         * Verifies a BoothParams message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a BoothParams message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns BoothParams
         */
        public static fromObject(object: { [k: string]: any }): meerkat.BoothParams;

        /**
         * Creates a plain object from a BoothParams message. Also converts values to other types if specified.
         * @param message BoothParams
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.BoothParams, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this BoothParams to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a BoothSystemMessages. */
    interface IBoothSystemMessages {

        /** BoothSystemMessages systemMessage */
        systemMessage?: { [k: string]: meerkat.IUIElement };
    }

    /** Represents a BoothSystemMessages. */
    class BoothSystemMessages {

        /**
         * Constructs a new BoothSystemMessages.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IBoothSystemMessages);

        /** BoothSystemMessages systemMessage. */
        public systemMessage: { [k: string]: meerkat.IUIElement };

        /**
         * Creates a new BoothSystemMessages instance using the specified properties.
         * @param [properties] Properties to set
         * @returns BoothSystemMessages instance
         */
        public static create(properties?: meerkat.IBoothSystemMessages): meerkat.BoothSystemMessages;

        /**
         * Encodes the specified BoothSystemMessages message. Does not implicitly {@link meerkat.BoothSystemMessages.verify|verify} messages.
         * @param message BoothSystemMessages message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IBoothSystemMessages, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified BoothSystemMessages message, length delimited. Does not implicitly {@link meerkat.BoothSystemMessages.verify|verify} messages.
         * @param message BoothSystemMessages message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IBoothSystemMessages, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a BoothSystemMessages message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns BoothSystemMessages
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.BoothSystemMessages;

        /**
         * Decodes a BoothSystemMessages message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns BoothSystemMessages
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.BoothSystemMessages;

        /**
         * Verifies a BoothSystemMessages message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a BoothSystemMessages message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns BoothSystemMessages
         */
        public static fromObject(object: { [k: string]: any }): meerkat.BoothSystemMessages;

        /**
         * Creates a plain object from a BoothSystemMessages message. Also converts values to other types if specified.
         * @param message BoothSystemMessages
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.BoothSystemMessages, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this BoothSystemMessages to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a BallotAnswerTranslationTable. */
    interface IBallotAnswerTranslationTable {

        /** BallotAnswerTranslationTable data */
        data?: Uint8Array;
    }

    /** Represents a BallotAnswerTranslationTable. */
    class BallotAnswerTranslationTable {

        /**
         * Constructs a new BallotAnswerTranslationTable.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IBallotAnswerTranslationTable);

        /** BallotAnswerTranslationTable data. */
        public data: Uint8Array;

        /**
         * Creates a new BallotAnswerTranslationTable instance using the specified properties.
         * @param [properties] Properties to set
         * @returns BallotAnswerTranslationTable instance
         */
        public static create(properties?: meerkat.IBallotAnswerTranslationTable): meerkat.BallotAnswerTranslationTable;

        /**
         * Encodes the specified BallotAnswerTranslationTable message. Does not implicitly {@link meerkat.BallotAnswerTranslationTable.verify|verify} messages.
         * @param message BallotAnswerTranslationTable message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IBallotAnswerTranslationTable, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified BallotAnswerTranslationTable message, length delimited. Does not implicitly {@link meerkat.BallotAnswerTranslationTable.verify|verify} messages.
         * @param message BallotAnswerTranslationTable message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IBallotAnswerTranslationTable, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a BallotAnswerTranslationTable message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns BallotAnswerTranslationTable
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.BallotAnswerTranslationTable;

        /**
         * Decodes a BallotAnswerTranslationTable message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns BallotAnswerTranslationTable
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.BallotAnswerTranslationTable;

        /**
         * Verifies a BallotAnswerTranslationTable message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a BallotAnswerTranslationTable message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns BallotAnswerTranslationTable
         */
        public static fromObject(object: { [k: string]: any }): meerkat.BallotAnswerTranslationTable;

        /**
         * Creates a plain object from a BallotAnswerTranslationTable message. Also converts values to other types if specified.
         * @param message BallotAnswerTranslationTable
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.BallotAnswerTranslationTable, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this BallotAnswerTranslationTable to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a BulletinBoardClientParams. */
    interface IBulletinBoardClientParams {

        /** BulletinBoardClientParams bulletinBoardAddress */
        bulletinBoardAddress?: string[];

        /** BulletinBoardClientParams minRedundancy */
        minRedundancy?: number;
    }

    /** Represents a BulletinBoardClientParams. */
    class BulletinBoardClientParams {

        /**
         * Constructs a new BulletinBoardClientParams.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IBulletinBoardClientParams);

        /** BulletinBoardClientParams bulletinBoardAddress. */
        public bulletinBoardAddress: string[];

        /** BulletinBoardClientParams minRedundancy. */
        public minRedundancy: number;

        /**
         * Creates a new BulletinBoardClientParams instance using the specified properties.
         * @param [properties] Properties to set
         * @returns BulletinBoardClientParams instance
         */
        public static create(properties?: meerkat.IBulletinBoardClientParams): meerkat.BulletinBoardClientParams;

        /**
         * Encodes the specified BulletinBoardClientParams message. Does not implicitly {@link meerkat.BulletinBoardClientParams.verify|verify} messages.
         * @param message BulletinBoardClientParams message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IBulletinBoardClientParams, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified BulletinBoardClientParams message, length delimited. Does not implicitly {@link meerkat.BulletinBoardClientParams.verify|verify} messages.
         * @param message BulletinBoardClientParams message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IBulletinBoardClientParams, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a BulletinBoardClientParams message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns BulletinBoardClientParams
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.BulletinBoardClientParams;

        /**
         * Decodes a BulletinBoardClientParams message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns BulletinBoardClientParams
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.BulletinBoardClientParams;

        /**
         * Verifies a BulletinBoardClientParams message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a BulletinBoardClientParams message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns BulletinBoardClientParams
         */
        public static fromObject(object: { [k: string]: any }): meerkat.BulletinBoardClientParams;

        /**
         * Creates a plain object from a BulletinBoardClientParams message. Also converts values to other types if specified.
         * @param message BulletinBoardClientParams
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.BulletinBoardClientParams, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this BulletinBoardClientParams to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of an ElectionParams. */
    interface IElectionParams {

        /** ElectionParams trusteeVerificationKeys */
        trusteeVerificationKeys?: meerkat.ISignatureVerificationKey[];

        /** ElectionParams trusteeSignatureThreshold */
        trusteeSignatureThreshold?: number;

        /** ElectionParams ballotEncryptionKey */
        ballotEncryptionKey?: meerkat.IEncryptionPublicKey;

        /** ElectionParams mixerVerificationKeys */
        mixerVerificationKeys?: meerkat.ISignatureVerificationKey[];

        /** ElectionParams mixerThreshold */
        mixerThreshold?: number;

        /** ElectionParams channelChoiceQuestions */
        channelChoiceQuestions?: meerkat.IBallotQuestion[];

        /** ElectionParams selectionData */
        selectionData?: meerkat.ISimpleCategoriesSelectionData;

        /** ElectionParams raceQuestions */
        raceQuestions?: meerkat.IBallotQuestion[];

        /** ElectionParams bulletinBoardClientParams */
        bulletinBoardClientParams?: meerkat.IBulletinBoardClientParams;
    }

    /** Represents an ElectionParams. */
    class ElectionParams {

        /**
         * Constructs a new ElectionParams.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.IElectionParams);

        /** ElectionParams trusteeVerificationKeys. */
        public trusteeVerificationKeys: meerkat.ISignatureVerificationKey[];

        /** ElectionParams trusteeSignatureThreshold. */
        public trusteeSignatureThreshold: number;

        /** ElectionParams ballotEncryptionKey. */
        public ballotEncryptionKey?: (meerkat.IEncryptionPublicKey|null);

        /** ElectionParams mixerVerificationKeys. */
        public mixerVerificationKeys: meerkat.ISignatureVerificationKey[];

        /** ElectionParams mixerThreshold. */
        public mixerThreshold: number;

        /** ElectionParams channelChoiceQuestions. */
        public channelChoiceQuestions: meerkat.IBallotQuestion[];

        /** ElectionParams selectionData. */
        public selectionData?: (meerkat.ISimpleCategoriesSelectionData|null);

        /** ElectionParams raceQuestions. */
        public raceQuestions: meerkat.IBallotQuestion[];

        /** ElectionParams bulletinBoardClientParams. */
        public bulletinBoardClientParams?: (meerkat.IBulletinBoardClientParams|null);

        /**
         * Creates a new ElectionParams instance using the specified properties.
         * @param [properties] Properties to set
         * @returns ElectionParams instance
         */
        public static create(properties?: meerkat.IElectionParams): meerkat.ElectionParams;

        /**
         * Encodes the specified ElectionParams message. Does not implicitly {@link meerkat.ElectionParams.verify|verify} messages.
         * @param message ElectionParams message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.IElectionParams, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified ElectionParams message, length delimited. Does not implicitly {@link meerkat.ElectionParams.verify|verify} messages.
         * @param message ElectionParams message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.IElectionParams, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes an ElectionParams message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns ElectionParams
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.ElectionParams;

        /**
         * Decodes an ElectionParams message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns ElectionParams
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.ElectionParams;

        /**
         * Verifies an ElectionParams message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates an ElectionParams message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns ElectionParams
         */
        public static fromObject(object: { [k: string]: any }): meerkat.ElectionParams;

        /**
         * Creates a plain object from an ElectionParams message. Also converts values to other types if specified.
         * @param message ElectionParams
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.ElectionParams, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this ElectionParams to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a Category. */
    interface ICategory {

        /** Category questionIndex */
        questionIndex?: number[];
    }

    /** Represents a Category. */
    class Category {

        /**
         * Constructs a new Category.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.ICategory);

        /** Category questionIndex. */
        public questionIndex: number[];

        /**
         * Creates a new Category instance using the specified properties.
         * @param [properties] Properties to set
         * @returns Category instance
         */
        public static create(properties?: meerkat.ICategory): meerkat.Category;

        /**
         * Encodes the specified Category message. Does not implicitly {@link meerkat.Category.verify|verify} messages.
         * @param message Category message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.ICategory, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified Category message, length delimited. Does not implicitly {@link meerkat.Category.verify|verify} messages.
         * @param message Category message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.ICategory, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a Category message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns Category
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.Category;

        /**
         * Decodes a Category message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns Category
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.Category;

        /**
         * Verifies a Category message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a Category message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns Category
         */
        public static fromObject(object: { [k: string]: any }): meerkat.Category;

        /**
         * Creates a plain object from a Category message. Also converts values to other types if specified.
         * @param message Category
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.Category, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this Category to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a CategoryChooser. */
    interface ICategoryChooser {

        /** CategoryChooser category */
        category?: meerkat.ICategory[];
    }

    /** Represents a CategoryChooser. */
    class CategoryChooser {

        /**
         * Constructs a new CategoryChooser.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.ICategoryChooser);

        /** CategoryChooser category. */
        public category: meerkat.ICategory[];

        /**
         * Creates a new CategoryChooser instance using the specified properties.
         * @param [properties] Properties to set
         * @returns CategoryChooser instance
         */
        public static create(properties?: meerkat.ICategoryChooser): meerkat.CategoryChooser;

        /**
         * Encodes the specified CategoryChooser message. Does not implicitly {@link meerkat.CategoryChooser.verify|verify} messages.
         * @param message CategoryChooser message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.ICategoryChooser, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified CategoryChooser message, length delimited. Does not implicitly {@link meerkat.CategoryChooser.verify|verify} messages.
         * @param message CategoryChooser message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.ICategoryChooser, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a CategoryChooser message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns CategoryChooser
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.CategoryChooser;

        /**
         * Decodes a CategoryChooser message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns CategoryChooser
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.CategoryChooser;

        /**
         * Verifies a CategoryChooser message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a CategoryChooser message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns CategoryChooser
         */
        public static fromObject(object: { [k: string]: any }): meerkat.CategoryChooser;

        /**
         * Creates a plain object from a CategoryChooser message. Also converts values to other types if specified.
         * @param message CategoryChooser
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.CategoryChooser, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this CategoryChooser to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a SimpleCategoriesSelectionData. */
    interface ISimpleCategoriesSelectionData {

        /** SimpleCategoriesSelectionData sharedDefaults */
        sharedDefaults?: meerkat.ICategory;

        /** SimpleCategoriesSelectionData categoryChooser */
        categoryChooser?: meerkat.ICategoryChooser[];
    }

    /** Represents a SimpleCategoriesSelectionData. */
    class SimpleCategoriesSelectionData {

        /**
         * Constructs a new SimpleCategoriesSelectionData.
         * @param [properties] Properties to set
         */
        constructor(properties?: meerkat.ISimpleCategoriesSelectionData);

        /** SimpleCategoriesSelectionData sharedDefaults. */
        public sharedDefaults?: (meerkat.ICategory|null);

        /** SimpleCategoriesSelectionData categoryChooser. */
        public categoryChooser: meerkat.ICategoryChooser[];

        /**
         * Creates a new SimpleCategoriesSelectionData instance using the specified properties.
         * @param [properties] Properties to set
         * @returns SimpleCategoriesSelectionData instance
         */
        public static create(properties?: meerkat.ISimpleCategoriesSelectionData): meerkat.SimpleCategoriesSelectionData;

        /**
         * Encodes the specified SimpleCategoriesSelectionData message. Does not implicitly {@link meerkat.SimpleCategoriesSelectionData.verify|verify} messages.
         * @param message SimpleCategoriesSelectionData message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: meerkat.ISimpleCategoriesSelectionData, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified SimpleCategoriesSelectionData message, length delimited. Does not implicitly {@link meerkat.SimpleCategoriesSelectionData.verify|verify} messages.
         * @param message SimpleCategoriesSelectionData message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: meerkat.ISimpleCategoriesSelectionData, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a SimpleCategoriesSelectionData message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns SimpleCategoriesSelectionData
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): meerkat.SimpleCategoriesSelectionData;

        /**
         * Decodes a SimpleCategoriesSelectionData message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns SimpleCategoriesSelectionData
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): meerkat.SimpleCategoriesSelectionData;

        /**
         * Verifies a SimpleCategoriesSelectionData message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a SimpleCategoriesSelectionData message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns SimpleCategoriesSelectionData
         */
        public static fromObject(object: { [k: string]: any }): meerkat.SimpleCategoriesSelectionData;

        /**
         * Creates a plain object from a SimpleCategoriesSelectionData message. Also converts values to other types if specified.
         * @param message SimpleCategoriesSelectionData
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: meerkat.SimpleCategoriesSelectionData, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this SimpleCategoriesSelectionData to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }
}

/** Namespace google. */
export namespace google {

    /** Namespace protobuf. */
    namespace protobuf {

        /** Properties of a Timestamp. */
        interface ITimestamp {

            /** Timestamp seconds */
            seconds?: (number|Long);

            /** Timestamp nanos */
            nanos?: number;
        }

        /** Represents a Timestamp. */
        class Timestamp {

            /**
             * Constructs a new Timestamp.
             * @param [properties] Properties to set
             */
            constructor(properties?: google.protobuf.ITimestamp);

            /** Timestamp seconds. */
            public seconds: (number|Long);

            /** Timestamp nanos. */
            public nanos: number;

            /**
             * Creates a new Timestamp instance using the specified properties.
             * @param [properties] Properties to set
             * @returns Timestamp instance
             */
            public static create(properties?: google.protobuf.ITimestamp): google.protobuf.Timestamp;

            /**
             * Encodes the specified Timestamp message. Does not implicitly {@link google.protobuf.Timestamp.verify|verify} messages.
             * @param message Timestamp message or plain object to encode
             * @param [writer] Writer to encode to
             * @returns Writer
             */
            public static encode(message: google.protobuf.ITimestamp, writer?: $protobuf.Writer): $protobuf.Writer;

            /**
             * Encodes the specified Timestamp message, length delimited. Does not implicitly {@link google.protobuf.Timestamp.verify|verify} messages.
             * @param message Timestamp message or plain object to encode
             * @param [writer] Writer to encode to
             * @returns Writer
             */
            public static encodeDelimited(message: google.protobuf.ITimestamp, writer?: $protobuf.Writer): $protobuf.Writer;

            /**
             * Decodes a Timestamp message from the specified reader or buffer.
             * @param reader Reader or buffer to decode from
             * @param [length] Message length if known beforehand
             * @returns Timestamp
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): google.protobuf.Timestamp;

            /**
             * Decodes a Timestamp message from the specified reader or buffer, length delimited.
             * @param reader Reader or buffer to decode from
             * @returns Timestamp
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): google.protobuf.Timestamp;

            /**
             * Verifies a Timestamp message.
             * @param message Plain object to verify
             * @returns `null` if valid, otherwise the reason why it is not
             */
            public static verify(message: { [k: string]: any }): (string|null);

            /**
             * Creates a Timestamp message from a plain object. Also converts values to their respective internal types.
             * @param object Plain object
             * @returns Timestamp
             */
            public static fromObject(object: { [k: string]: any }): google.protobuf.Timestamp;

            /**
             * Creates a plain object from a Timestamp message. Also converts values to other types if specified.
             * @param message Timestamp
             * @param [options] Conversion options
             * @returns Plain object
             */
            public static toObject(message: google.protobuf.Timestamp, options?: $protobuf.IConversionOptions): { [k: string]: any };

            /**
             * Converts this Timestamp to JSON.
             * @returns JSON object
             */
            public toJSON(): { [k: string]: any };
        }
    }
}
